/// Represents a individual programming language. Can be used to provide
/// information about the language, such as multi line comments, single line
/// comments, string literal syntax, whether a given language allows nesting
/// comments.
#[derive(Deserialize, Serialize)]
#[derive(Clone, Copy, Debug, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub enum LanguageType {
        #[allow(missing_docs)]Abap,
    
        #[allow(missing_docs)]ActionScript,
    
        #[allow(missing_docs)]Ada,
    
        #[allow(missing_docs)]Agda,
    
        #[allow(missing_docs)]Alex,
    
        #[allow(missing_docs)]Asn1,
    
        #[allow(missing_docs)]Asp,
    
        #[allow(missing_docs)]AspNet,
    
        #[allow(missing_docs)]Assembly,
    
        #[allow(missing_docs)]AutoHotKey,
    
        #[allow(missing_docs)]Autoconf,
    
        #[allow(missing_docs)]Automake,
    
        #[allow(missing_docs)]Bash,
    
        #[allow(missing_docs)]Batch,
    
        #[allow(missing_docs)]BrightScript,
    
        #[allow(missing_docs)]C,
    
        #[allow(missing_docs)]CHeader,
    
        #[allow(missing_docs)]CMake,
    
        #[allow(missing_docs)]CSharp,
    
        #[allow(missing_docs)]CShell,
    
        #[allow(missing_docs)]Cabal,
    
        #[allow(missing_docs)]Cassius,
    
        #[allow(missing_docs)]Ceylon,
    
        #[allow(missing_docs)]Clojure,
    
        #[allow(missing_docs)]ClojureC,
    
        #[allow(missing_docs)]ClojureScript,
    
        #[allow(missing_docs)]Cobol,
    
        #[allow(missing_docs)]CoffeeScript,
    
        #[allow(missing_docs)]Cogent,
    
        #[allow(missing_docs)]ColdFusion,
    
        #[allow(missing_docs)]ColdFusionScript,
    
        #[allow(missing_docs)]Coq,
    
        #[allow(missing_docs)]Cpp,
    
        #[allow(missing_docs)]CppHeader,
    
        #[allow(missing_docs)]Crystal,
    
        #[allow(missing_docs)]Css,
    
        #[allow(missing_docs)]D,
    
        #[allow(missing_docs)]Dart,
    
        #[allow(missing_docs)]DeviceTree,
    
        #[allow(missing_docs)]Dockerfile,
    
        #[allow(missing_docs)]DotNetResource,
    
        #[allow(missing_docs)]DreamMaker,
    
        #[allow(missing_docs)]Edn,
    
        #[allow(missing_docs)]Elisp,
    
        #[allow(missing_docs)]Elixir,
    
        #[allow(missing_docs)]Elm,
    
        #[allow(missing_docs)]Elvish,
    
        #[allow(missing_docs)]EmacsDevEnv,
    
        #[allow(missing_docs)]Emojicode,
    
        #[allow(missing_docs)]Erlang,
    
        #[allow(missing_docs)]FEN,
    
        #[allow(missing_docs)]FSharp,
    
        #[allow(missing_docs)]Fish,
    
        #[allow(missing_docs)]FlatBuffers,
    
        #[allow(missing_docs)]Forth,
    
        #[allow(missing_docs)]FortranLegacy,
    
        #[allow(missing_docs)]FortranModern,
    
        #[allow(missing_docs)]Fstar,
    
        #[allow(missing_docs)]GdScript,
    
        #[allow(missing_docs)]Glsl,
    
        #[allow(missing_docs)]Go,
    
        #[allow(missing_docs)]Graphql,
    
        #[allow(missing_docs)]Groovy,
    
        #[allow(missing_docs)]Hamlet,
    
        #[allow(missing_docs)]Handlebars,
    
        #[allow(missing_docs)]Happy,
    
        #[allow(missing_docs)]Haskell,
    
        #[allow(missing_docs)]Haxe,
    
        #[allow(missing_docs)]Hcl,
    
        #[allow(missing_docs)]Hex,
    
        #[allow(missing_docs)]Hlsl,
    
        #[allow(missing_docs)]HolyC,
    
        #[allow(missing_docs)]Html,
    
        #[allow(missing_docs)]Idris,
    
        #[allow(missing_docs)]Ini,
    
        #[allow(missing_docs)]IntelHex,
    
        #[allow(missing_docs)]Isabelle,
    
        #[allow(missing_docs)]Jai,
    
        #[allow(missing_docs)]Java,
    
        #[allow(missing_docs)]JavaScript,
    
        #[allow(missing_docs)]Json,
    
        #[allow(missing_docs)]Jsx,
    
        #[allow(missing_docs)]Julia,
    
        #[allow(missing_docs)]Julius,
    
        #[allow(missing_docs)]KakouneScript,
    
        #[allow(missing_docs)]Kotlin,
    
        #[allow(missing_docs)]LLVM,
    
        #[allow(missing_docs)]Lean,
    
        #[allow(missing_docs)]Less,
    
        #[allow(missing_docs)]LinkerScript,
    
        #[allow(missing_docs)]Liquid,
    
        #[allow(missing_docs)]Lisp,
    
        #[allow(missing_docs)]Logtalk,
    
        #[allow(missing_docs)]Lua,
    
        #[allow(missing_docs)]Lucius,
    
        #[allow(missing_docs)]Madlang,
    
        #[allow(missing_docs)]Makefile,
    
        #[allow(missing_docs)]Markdown,
    
        #[allow(missing_docs)]Meson,
    
        #[allow(missing_docs)]Mint,
    
        #[allow(missing_docs)]ModuleDef,
    
        #[allow(missing_docs)]MoonScript,
    
        #[allow(missing_docs)]MsBuild,
    
        #[allow(missing_docs)]Mustache,
    
        #[allow(missing_docs)]Nim,
    
        #[allow(missing_docs)]Nix,
    
        #[allow(missing_docs)]NotQuitePerl,
    
        #[allow(missing_docs)]OCaml,
    
        #[allow(missing_docs)]ObjectiveC,
    
        #[allow(missing_docs)]ObjectiveCpp,
    
        #[allow(missing_docs)]Odin,
    
        #[allow(missing_docs)]Org,
    
        #[allow(missing_docs)]Oz,
    
        #[allow(missing_docs)]PSL,
    
        #[allow(missing_docs)]Pascal,
    
        #[allow(missing_docs)]Perl,
    
        #[allow(missing_docs)]Perl6,
    
        #[allow(missing_docs)]Pest,
    
        #[allow(missing_docs)]Php,
    
        #[allow(missing_docs)]Polly,
    
        #[allow(missing_docs)]Pony,
    
        #[allow(missing_docs)]PostCss,
    
        #[allow(missing_docs)]PowerShell,
    
        #[allow(missing_docs)]Processing,
    
        #[allow(missing_docs)]Prolog,
    
        #[allow(missing_docs)]Protobuf,
    
        #[allow(missing_docs)]PureScript,
    
        #[allow(missing_docs)]Python,
    
        #[allow(missing_docs)]Qcl,
    
        #[allow(missing_docs)]Qml,
    
        #[allow(missing_docs)]R,
    
        #[allow(missing_docs)]RON,
    
        #[allow(missing_docs)]RPMSpecfile,
    
        #[allow(missing_docs)]Racket,
    
        #[allow(missing_docs)]Rakefile,
    
        #[allow(missing_docs)]Razor,
    
        #[allow(missing_docs)]ReStructuredText,
    
        #[allow(missing_docs)]Ruby,
    
        #[allow(missing_docs)]RubyHtml,
    
        #[allow(missing_docs)]Rust,
    
        #[allow(missing_docs)]SRecode,
    
        #[allow(missing_docs)]Sass,
    
        #[allow(missing_docs)]Scala,
    
        #[allow(missing_docs)]Scheme,
    
        #[allow(missing_docs)]Scons,
    
        #[allow(missing_docs)]Sh,
    
        #[allow(missing_docs)]Sml,
    
        #[allow(missing_docs)]Solidity,
    
        #[allow(missing_docs)]SpecmanE,
    
        #[allow(missing_docs)]Spice,
    
        #[allow(missing_docs)]Sql,
    
        #[allow(missing_docs)]Stratego,
    
        #[allow(missing_docs)]Svg,
    
        #[allow(missing_docs)]Swift,
    
        #[allow(missing_docs)]Swig,
    
        #[allow(missing_docs)]SystemVerilog,
    
        #[allow(missing_docs)]Tcl,
    
        #[allow(missing_docs)]Tex,
    
        #[allow(missing_docs)]Text,
    
        #[allow(missing_docs)]Thrift,
    
        #[allow(missing_docs)]Toml,
    
        #[allow(missing_docs)]Twig,
    
        #[allow(missing_docs)]TypeScript,
    
        #[allow(missing_docs)]UnrealDeveloperMarkdown,
    
        #[allow(missing_docs)]UnrealPlugin,
    
        #[allow(missing_docs)]UnrealProject,
    
        #[allow(missing_docs)]UnrealScript,
    
        #[allow(missing_docs)]UnrealShader,
    
        #[allow(missing_docs)]UnrealShaderHeader,
    
        #[allow(missing_docs)]UrWeb,
    
        #[allow(missing_docs)]UrWebProject,
    
        #[allow(missing_docs)]VB6,
    
        #[allow(missing_docs)]VBScript,
    
        #[allow(missing_docs)]Vala,
    
        #[allow(missing_docs)]Verilog,
    
        #[allow(missing_docs)]VerilogArgsFile,
    
        #[allow(missing_docs)]Vhdl,
    
        #[allow(missing_docs)]VimScript,
    
        #[allow(missing_docs)]VisualBasic,
    
        #[allow(missing_docs)]VisualStudioProject,
    
        #[allow(missing_docs)]VisualStudioSolution,
    
        #[allow(missing_docs)]Vue,
    
        #[allow(missing_docs)]WebAssembly,
    
        #[allow(missing_docs)]Wolfram,
    
        #[allow(missing_docs)]XSL,
    
        #[allow(missing_docs)]Xaml,
    
        #[allow(missing_docs)]XcodeConfig,
    
        #[allow(missing_docs)]Xml,
    
        #[allow(missing_docs)]Xtend,
    
        #[allow(missing_docs)]Yaml,
    
        #[allow(missing_docs)]Zig,
    
        #[allow(missing_docs)]Zsh,
    
}

impl LanguageType {

    pub(crate) fn blank_allows_nested() -> bool {
        false
    }

    pub(crate) fn blank_line_comments() -> &'static [&'static str] {
        &[]
    }

    pub(crate) fn blank_multi_line_comments()
        -> &'static [(&'static str, &'static str)]
    {
        &[]
    }

    pub(crate) fn blank_quotes() -> &'static [(&'static str, &'static str)] {
        &[]
    }

    pub(crate) fn c_allows_nested() -> bool {
        Self::blank_allows_nested()
    }

    pub(crate) fn c_line_comments() -> &'static [&'static str] {
        &["//"]
    }

    pub(crate) fn c_multi_line_comments()
        -> &'static [(&'static str, &'static str)]
    {
        &[("/*", "*/")]
    }

    pub(crate) fn c_quotes() -> &'static [(&'static str, &'static str)] {
        &[("\"", "\"")]
    }

    pub(crate) fn func_allows_nested() -> bool {
        Self::blank_allows_nested()
    }

    pub(crate) fn func_line_comments() -> &'static [&'static str] {
        Self::blank_line_comments()
    }

    pub(crate) fn func_multi_line_comments()
        -> &'static [(&'static str, &'static str)]
    {
        &[("(*", "*)")]
    }

    pub(crate) fn func_quotes() -> &'static [(&'static str, &'static str)] {
        Self::c_quotes()
    }

    pub(crate) fn hash_allows_nested() -> bool {
        Self::blank_allows_nested()
    }

    pub(crate) fn hash_line_comments() -> &'static [&'static str] {
        &["#"]
    }

    pub(crate) fn hash_multi_line_comments()
        -> &'static [(&'static str, &'static str)]
    {
        Self::blank_multi_line_comments()
    }

    pub(crate) fn hash_quotes() -> &'static [(&'static str, &'static str)] {
        Self::blank_quotes()
    }

    pub(crate) fn haskell_allows_nested() -> bool {
        true
    }

    pub(crate) fn haskell_line_comments() -> &'static [&'static str] {
        &["--"]
    }

    pub(crate) fn haskell_multi_line_comments()
        -> &'static [(&'static str, &'static str)]
    {
        &[("{-", "-}")]
    }

    pub(crate) fn haskell_quotes() -> &'static [(&'static str, &'static str)] {
        Self::blank_quotes()
    }

    pub(crate) fn html_allows_nested() -> bool {
        Self::blank_allows_nested()
    }

    pub(crate) fn html_line_comments() -> &'static [&'static str] {
        Self::blank_line_comments()
    }

    pub(crate) fn html_multi_line_comments()
        -> &'static [(&'static str, &'static str)]
    {
        &[("<!--", "-->")]
    }

    pub(crate) fn html_quotes() -> &'static [(&'static str, &'static str)] {
        Self::c_quotes()
    }

    pub(crate) fn pro_allows_nested() -> bool {
        Self::blank_allows_nested()
    }

    pub(crate) fn pro_line_comments() -> &'static [&'static str] {
        &["%"]
    }

    pub(crate) fn pro_multi_line_comments()
        -> &'static [(&'static str, &'static str)]
    {
        &[("/*", "*/")]
    }

    pub(crate) fn pro_quotes() -> &'static [(&'static str, &'static str)] {
        Self::c_quotes()
    }

    /// Returns the display name of a language.
    ///
    /// ```
    /// # use tokei::*;
    /// let bash = LanguageType::Bash;
    ///
    /// assert_eq!(bash.name(), "BASH");
    /// ```
    pub fn name(self) -> &'static str {
        match self {
                Abap =>
                
                    "ABAP"
                ,
                ActionScript =>
                
                    "ActionScript",
                Ada =>
                
                    "Ada",
                Agda =>
                
                    "Agda",
                Alex =>
                
                    "Alex",
                Asn1 =>
                
                    "ASN.1"
                ,
                Asp =>
                
                    "ASP"
                ,
                AspNet =>
                
                    "ASP.NET"
                ,
                Assembly =>
                
                    "Assembly",
                AutoHotKey =>
                
                    "AutoHotKey",
                Autoconf =>
                
                    "Autoconf",
                Automake =>
                
                    "Automake",
                Bash =>
                
                    "BASH"
                ,
                Batch =>
                
                    "Batch",
                BrightScript =>
                
                    "BrightScript",
                C =>
                
                    "C",
                CHeader =>
                
                    "C Header"
                ,
                CMake =>
                
                    "CMake",
                CSharp =>
                
                    "C#"
                ,
                CShell =>
                
                    "C Shell"
                ,
                Cabal =>
                
                    "Cabal",
                Cassius =>
                
                    "Cassius",
                Ceylon =>
                
                    "Ceylon",
                Clojure =>
                
                    "Clojure",
                ClojureC =>
                
                    "ClojureC",
                ClojureScript =>
                
                    "ClojureScript",
                Cobol =>
                
                    "COBOL"
                ,
                CoffeeScript =>
                
                    "CoffeeScript",
                Cogent =>
                
                    "Cogent",
                ColdFusion =>
                
                    "ColdFusion",
                ColdFusionScript =>
                
                    "ColdFusion CFScript"
                ,
                Coq =>
                
                    "Coq",
                Cpp =>
                
                    "C++"
                ,
                CppHeader =>
                
                    "C++ Header"
                ,
                Crystal =>
                
                    "Crystal",
                Css =>
                
                    "CSS"
                ,
                D =>
                
                    "D",
                Dart =>
                
                    "Dart",
                DeviceTree =>
                
                    "Device Tree"
                ,
                Dockerfile =>
                
                    "Dockerfile",
                DotNetResource =>
                
                    ".NET Resource"
                ,
                DreamMaker =>
                
                    "Dream Maker"
                ,
                Edn =>
                
                    "Edn",
                Elisp =>
                
                    "Emacs Lisp"
                ,
                Elixir =>
                
                    "Elixir",
                Elm =>
                
                    "Elm",
                Elvish =>
                
                    "Elvish",
                EmacsDevEnv =>
                
                    "Emacs Dev Env"
                ,
                Emojicode =>
                
                    "Emojicode",
                Erlang =>
                
                    "Erlang",
                FEN =>
                
                    "FEN"
                ,
                FSharp =>
                
                    "F#"
                ,
                Fish =>
                
                    "Fish",
                FlatBuffers =>
                
                    "FlatBuffers Schema"
                ,
                Forth =>
                
                    "Forth",
                FortranLegacy =>
                
                    "FORTRAN Legacy"
                ,
                FortranModern =>
                
                    "FORTRAN Modern"
                ,
                Fstar =>
                
                    "F*"
                ,
                GdScript =>
                
                    "GDScript"
                ,
                Glsl =>
                
                    "GLSL"
                ,
                Go =>
                
                    "Go",
                Graphql =>
                
                    "GraphQL"
                ,
                Groovy =>
                
                    "Groovy",
                Hamlet =>
                
                    "Hamlet",
                Handlebars =>
                
                    "Handlebars",
                Happy =>
                
                    "Happy",
                Haskell =>
                
                    "Haskell",
                Haxe =>
                
                    "Haxe",
                Hcl =>
                
                    "HCL"
                ,
                Hex =>
                
                    "HEX"
                ,
                Hlsl =>
                
                    "HLSL"
                ,
                HolyC =>
                
                    "HolyC",
                Html =>
                
                    "HTML"
                ,
                Idris =>
                
                    "Idris",
                Ini =>
                
                    "INI"
                ,
                IntelHex =>
                
                    "Intel HEX"
                ,
                Isabelle =>
                
                    "Isabelle",
                Jai =>
                
                    "JAI"
                ,
                Java =>
                
                    "Java",
                JavaScript =>
                
                    "JavaScript",
                Json =>
                
                    "JSON"
                ,
                Jsx =>
                
                    "JSX"
                ,
                Julia =>
                
                    "Julia",
                Julius =>
                
                    "Julius",
                KakouneScript =>
                
                    "Kakoune script"
                ,
                Kotlin =>
                
                    "Kotlin",
                LLVM =>
                
                    "LLVM",
                Lean =>
                
                    "Lean",
                Less =>
                
                    "LESS"
                ,
                LinkerScript =>
                
                    "LD Script"
                ,
                Liquid =>
                
                    "Liquid"
                ,
                Lisp =>
                
                    "Lisp",
                Logtalk =>
                
                    "Logtalk",
                Lua =>
                
                    "Lua",
                Lucius =>
                
                    "Lucius",
                Madlang =>
                
                    "Madlang",
                Makefile =>
                
                    "Makefile",
                Markdown =>
                
                    "Markdown",
                Meson =>
                
                    "Meson",
                Mint =>
                
                    "Mint",
                ModuleDef =>
                
                    "Module-Definition"
                ,
                MoonScript =>
                
                    "MoonScript",
                MsBuild =>
                
                    "MSBuild"
                ,
                Mustache =>
                
                    "Mustache",
                Nim =>
                
                    "Nim",
                Nix =>
                
                    "Nix",
                NotQuitePerl =>
                
                    "Not Quite Perl"
                ,
                OCaml =>
                
                    "OCaml",
                ObjectiveC =>
                
                    "Objective-C"
                ,
                ObjectiveCpp =>
                
                    "Objective-C++"
                ,
                Odin =>
                
                    "Odin",
                Org =>
                
                    "Org",
                Oz =>
                
                    "Oz",
                PSL =>
                
                    "PSL Assertion"
                ,
                Pascal =>
                
                    "Pascal",
                Perl =>
                
                    "Perl",
                Perl6 =>
                
                    "Perl6",
                Pest =>
                
                    "Pest",
                Php =>
                
                    "PHP"
                ,
                Polly =>
                
                    "Polly",
                Pony =>
                
                    "Pony",
                PostCss =>
                
                    "PostCSS"
                ,
                PowerShell =>
                
                    "PowerShell",
                Processing =>
                
                    "Processing",
                Prolog =>
                
                    "Prolog",
                Protobuf =>
                
                    "Protocol Buffers"
                ,
                PureScript =>
                
                    "PureScript",
                Python =>
                
                    "Python",
                Qcl =>
                
                    "QCL"
                ,
                Qml =>
                
                    "QML"
                ,
                R =>
                
                    "R",
                RON =>
                
                    "Rusty Object Notation"
                ,
                RPMSpecfile =>
                
                    "RPM Specfile"
                ,
                Racket =>
                
                    "Racket",
                Rakefile =>
                
                    "Rakefile",
                Razor =>
                
                    "Razor",
                ReStructuredText =>
                
                    "ReStructuredText",
                Ruby =>
                
                    "Ruby",
                RubyHtml =>
                
                    "Ruby HTML"
                ,
                Rust =>
                
                    "Rust",
                SRecode =>
                
                    "SRecode Template"
                ,
                Sass =>
                
                    "Sass",
                Scala =>
                
                    "Scala",
                Scheme =>
                
                    "Scheme",
                Scons =>
                
                    "Scons",
                Sh =>
                
                    "Shell"
                ,
                Sml =>
                
                    "Standard ML (SML)"
                ,
                Solidity =>
                
                    "Solidity"
                ,
                SpecmanE =>
                
                    "Specman e"
                ,
                Spice =>
                
                    "Spice Netlist"
                ,
                Sql =>
                
                    "SQL"
                ,
                Stratego =>
                
                    "Stratego/XT"
                ,
                Svg =>
                
                    "SVG"
                ,
                Swift =>
                
                    "Swift",
                Swig =>
                
                    "SWIG"
                ,
                SystemVerilog =>
                
                    "SystemVerilog",
                Tcl =>
                
                    "TCL"
                ,
                Tex =>
                
                    "TeX"
                ,
                Text =>
                
                    "Plain Text"
                ,
                Thrift =>
                
                    "Thrift",
                Toml =>
                
                    "TOML"
                ,
                Twig =>
                
                    "Twig"
                ,
                TypeScript =>
                
                    "TypeScript",
                UnrealDeveloperMarkdown =>
                
                    "Unreal Markdown"
                ,
                UnrealPlugin =>
                
                    "Unreal Plugin"
                ,
                UnrealProject =>
                
                    "Unreal Project"
                ,
                UnrealScript =>
                
                    "Unreal Script"
                ,
                UnrealShader =>
                
                    "Unreal Shader"
                ,
                UnrealShaderHeader =>
                
                    "Unreal Shader Header"
                ,
                UrWeb =>
                
                    "Ur/Web"
                ,
                UrWebProject =>
                
                    "Ur/Web Project"
                ,
                VB6 =>
                
                    "VB6"
                ,
                VBScript =>
                
                    "VBScript"
                ,
                Vala =>
                
                    "Vala",
                Verilog =>
                
                    "Verilog",
                VerilogArgsFile =>
                
                    "Verilog Args File"
                ,
                Vhdl =>
                
                    "VHDL"
                ,
                VimScript =>
                
                    "Vim Script"
                ,
                VisualBasic =>
                
                    "Visual Basic"
                ,
                VisualStudioProject =>
                
                    "Visual Studio Project"
                ,
                VisualStudioSolution =>
                
                    "Visual Studio Solution"
                ,
                Vue =>
                
                    "Vue"
                ,
                WebAssembly =>
                
                    "WebAssembly",
                Wolfram =>
                
                    "Wolfram",
                XSL =>
                
                    "XSL"
                ,
                Xaml =>
                
                    "XAML"
                ,
                XcodeConfig =>
                
                    "Xcode Config"
                ,
                Xml =>
                
                    "XML"
                ,
                Xtend =>
                
                    "Xtend",
                Yaml =>
                
                    "YAML"
                ,
                Zig =>
                
                    "Zig",
                Zsh =>
                
                    "Zsh",
        }
    }

    pub(crate) fn is_blank(self) -> bool {
        match self {
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    FEN => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    Hex => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
                    IntelHex => true,
                
            
                
            
                
            
                
            
                
            
                
                    Json => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    Markdown => true,
                
            
                
            
                
                    Mint => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    ReStructuredText => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
                    Text => true,
                
            
                
            
                
            
                
            
                
            
                
                    UnrealDeveloperMarkdown => true,
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
                
            
            _ => false,
        }
    }

    pub(crate) fn is_fortran(self) -> bool {
        self == LanguageType::FortranModern ||
        self == LanguageType::FortranLegacy
    }

    /// Provides every variant in a Vec
    pub fn list() -> &'static [Self] {
        &[
            
                Abap,
                ActionScript,
                Ada,
                Agda,
                Alex,
                Asn1,
                Asp,
                AspNet,
                Assembly,
                AutoHotKey,
                Autoconf,
                Automake,
                Bash,
                Batch,
                BrightScript,
                C,
                CHeader,
                CMake,
                CSharp,
                CShell,
                Cabal,
                Cassius,
                Ceylon,
                Clojure,
                ClojureC,
                ClojureScript,
                Cobol,
                CoffeeScript,
                Cogent,
                ColdFusion,
                ColdFusionScript,
                Coq,
                Cpp,
                CppHeader,
                Crystal,
                Css,
                D,
                Dart,
                DeviceTree,
                Dockerfile,
                DotNetResource,
                DreamMaker,
                Edn,
                Elisp,
                Elixir,
                Elm,
                Elvish,
                EmacsDevEnv,
                Emojicode,
                Erlang,
                FEN,
                FSharp,
                Fish,
                FlatBuffers,
                Forth,
                FortranLegacy,
                FortranModern,
                Fstar,
                GdScript,
                Glsl,
                Go,
                Graphql,
                Groovy,
                Hamlet,
                Handlebars,
                Happy,
                Haskell,
                Haxe,
                Hcl,
                Hex,
                Hlsl,
                HolyC,
                Html,
                Idris,
                Ini,
                IntelHex,
                Isabelle,
                Jai,
                Java,
                JavaScript,
                Json,
                Jsx,
                Julia,
                Julius,
                KakouneScript,
                Kotlin,
                LLVM,
                Lean,
                Less,
                LinkerScript,
                Liquid,
                Lisp,
                Logtalk,
                Lua,
                Lucius,
                Madlang,
                Makefile,
                Markdown,
                Meson,
                Mint,
                ModuleDef,
                MoonScript,
                MsBuild,
                Mustache,
                Nim,
                Nix,
                NotQuitePerl,
                OCaml,
                ObjectiveC,
                ObjectiveCpp,
                Odin,
                Org,
                Oz,
                PSL,
                Pascal,
                Perl,
                Perl6,
                Pest,
                Php,
                Polly,
                Pony,
                PostCss,
                PowerShell,
                Processing,
                Prolog,
                Protobuf,
                PureScript,
                Python,
                Qcl,
                Qml,
                R,
                RON,
                RPMSpecfile,
                Racket,
                Rakefile,
                Razor,
                ReStructuredText,
                Ruby,
                RubyHtml,
                Rust,
                SRecode,
                Sass,
                Scala,
                Scheme,
                Scons,
                Sh,
                Sml,
                Solidity,
                SpecmanE,
                Spice,
                Sql,
                Stratego,
                Svg,
                Swift,
                Swig,
                SystemVerilog,
                Tcl,
                Tex,
                Text,
                Thrift,
                Toml,
                Twig,
                TypeScript,
                UnrealDeveloperMarkdown,
                UnrealPlugin,
                UnrealProject,
                UnrealScript,
                UnrealShader,
                UnrealShaderHeader,
                UrWeb,
                UrWebProject,
                VB6,
                VBScript,
                Vala,
                Verilog,
                VerilogArgsFile,
                Vhdl,
                VimScript,
                VisualBasic,
                VisualStudioProject,
                VisualStudioSolution,
                Vue,
                WebAssembly,
                Wolfram,
                XSL,
                Xaml,
                XcodeConfig,
                Xml,
                Xtend,
                Yaml,
                Zig,
                Zsh,
        ]
    }

    /// Returns the single line comments of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Rust;
    /// assert_eq!(lang.line_comments(), &["//"]);
    /// ```
    pub fn line_comments(self) -> &'static [&'static str] {
        match self {
            Abap =>
                    
                        &[
                                "*",
                                "\"",
                        ],
                    ActionScript =>
                    
                        
                            Self::c_line_comments(),
                        Ada =>
                    
                        &[
                                "--",
                        ],
                    Agda =>
                    
                        
                            Self::haskell_line_comments(),
                        Alex =>
                    
                        
                            Self::blank_line_comments(),Asn1 =>
                    
                        &[
                                "--",
                        ],
                    Asp =>
                    
                        &[
                                "'",
                                "REM",
                        ],
                    AspNet =>
                    
                        
                            Self::blank_line_comments(),Assembly =>
                    
                        &[
                                ";",
                        ],
                    AutoHotKey =>
                    
                        &[
                                ";",
                        ],
                    Autoconf =>
                    
                        &[
                                "#",
                                "dnl",
                        ],
                    Automake =>
                    
                        
                            Self::hash_line_comments(),
                        Bash =>
                    
                        
                            Self::hash_line_comments(),
                        Batch =>
                    
                        &[
                                "REM",
                                "::",
                        ],
                    BrightScript =>
                    
                        &[
                                "'",
                                "REM",
                        ],
                    C =>
                    
                        
                            Self::c_line_comments(),
                        CHeader =>
                    
                        
                            Self::c_line_comments(),
                        CMake =>
                    
                        &[
                                "#",
                        ],
                    CSharp =>
                    
                        
                            Self::c_line_comments(),
                        CShell =>
                    
                        
                            Self::hash_line_comments(),
                        Cabal =>
                    
                        
                            Self::haskell_line_comments(),
                        Cassius =>
                    
                        
                            Self::c_line_comments(),
                        Ceylon =>
                    
                        
                            Self::c_line_comments(),
                        Clojure =>
                    
                        &[
                                ";",
                        ],
                    ClojureC =>
                    
                        &[
                                ";",
                        ],
                    ClojureScript =>
                    
                        &[
                                ";",
                        ],
                    Cobol =>
                    
                        &[
                                "*",
                        ],
                    CoffeeScript =>
                    
                        &[
                                "#",
                        ],
                    Cogent =>
                    
                        &[
                                "--",
                        ],
                    ColdFusion =>
                    
                        
                            Self::blank_line_comments(),ColdFusionScript =>
                    
                        
                            Self::c_line_comments(),
                        Coq =>
                    
                        
                            Self::func_line_comments(),
                        Cpp =>
                    
                        
                            Self::c_line_comments(),
                        CppHeader =>
                    
                        
                            Self::c_line_comments(),
                        Crystal =>
                    
                        &[
                                "#",
                        ],
                    Css =>
                    
                        
                            Self::c_line_comments(),
                        D =>
                    
                        
                            Self::c_line_comments(),
                        Dart =>
                    
                        
                            Self::c_line_comments(),
                        DeviceTree =>
                    
                        
                            Self::c_line_comments(),
                        Dockerfile =>
                    
                        &[
                                "#",
                        ],
                    DotNetResource =>
                    
                        
                            Self::html_line_comments(),
                        DreamMaker =>
                    
                        
                            Self::c_line_comments(),
                        Edn =>
                    
                        &[
                                ";",
                        ],
                    Elisp =>
                    
                        &[
                                ";",
                        ],
                    Elixir =>
                    
                        &[
                                "#",
                        ],
                    Elm =>
                    
                        
                            Self::haskell_line_comments(),
                        Elvish =>
                    
                        
                            Self::hash_line_comments(),
                        EmacsDevEnv =>
                    
                        &[
                                ";",
                        ],
                    Emojicode =>
                    
                        &[
                                "💭",
                        ],
                    Erlang =>
                    
                        &[
                                "%",
                        ],
                    FEN =>
                    
                        
                            Self::blank_line_comments(),FSharp =>
                    
                        &[
                                "//",
                        ],
                    Fish =>
                    
                        
                            Self::hash_line_comments(),
                        FlatBuffers =>
                    
                        
                            Self::c_line_comments(),
                        Forth =>
                    
                        &[
                                "\\",
                        ],
                    FortranLegacy =>
                    
                        &[
                                "c",
                                "C",
                                "!",
                                "*",
                        ],
                    FortranModern =>
                    
                        &[
                                "!",
                        ],
                    Fstar =>
                    
                        
                            Self::func_line_comments(),
                        GdScript =>
                    
                        
                            Self::hash_line_comments(),
                        Glsl =>
                    
                        
                            Self::c_line_comments(),
                        Go =>
                    
                        
                            Self::c_line_comments(),
                        Graphql =>
                    
                        &[
                                "#",
                        ],
                    Groovy =>
                    
                        
                            Self::c_line_comments(),
                        Hamlet =>
                    
                        
                            Self::html_line_comments(),
                        Handlebars =>
                    
                        
                            Self::blank_line_comments(),Happy =>
                    
                        
                            Self::blank_line_comments(),Haskell =>
                    
                        
                            Self::haskell_line_comments(),
                        Haxe =>
                    
                        
                            Self::c_line_comments(),
                        Hcl =>
                    
                        &[
                                "#",
                                "//",
                        ],
                    Hex =>
                    
                        
                            Self::blank_line_comments(),Hlsl =>
                    
                        
                            Self::c_line_comments(),
                        HolyC =>
                    
                        
                            Self::c_line_comments(),
                        Html =>
                    
                        
                            Self::html_line_comments(),
                        Idris =>
                    
                        
                            Self::haskell_line_comments(),
                        Ini =>
                    
                        &[
                                ";",
                                "#",
                        ],
                    IntelHex =>
                    
                        
                            Self::blank_line_comments(),Isabelle =>
                    
                        &[
                                "--",
                        ],
                    Jai =>
                    
                        
                            Self::c_line_comments(),
                        Java =>
                    
                        
                            Self::c_line_comments(),
                        JavaScript =>
                    
                        
                            Self::c_line_comments(),
                        Json =>
                    
                        
                            Self::blank_line_comments(),Jsx =>
                    
                        
                            Self::c_line_comments(),
                        Julia =>
                    
                        &[
                                "#",
                        ],
                    Julius =>
                    
                        
                            Self::c_line_comments(),
                        KakouneScript =>
                    
                        &[
                                "#",
                        ],
                    Kotlin =>
                    
                        
                            Self::c_line_comments(),
                        LLVM =>
                    
                        &[
                                ";",
                        ],
                    Lean =>
                    
                        &[
                                "--",
                        ],
                    Less =>
                    
                        
                            Self::c_line_comments(),
                        LinkerScript =>
                    
                        
                            Self::c_line_comments(),
                        Liquid =>
                    
                        
                            Self::html_line_comments(),
                        Lisp =>
                    
                        &[
                                ";",
                        ],
                    Logtalk =>
                    
                        
                            Self::pro_line_comments(),
                        Lua =>
                    
                        &[
                                "--",
                        ],
                    Lucius =>
                    
                        
                            Self::c_line_comments(),
                        Madlang =>
                    
                        &[
                                "#",
                        ],
                    Makefile =>
                    
                        
                            Self::hash_line_comments(),
                        Markdown =>
                    
                        
                            Self::blank_line_comments(),Meson =>
                    
                        &[
                                "#",
                        ],
                    Mint =>
                    
                        
                            Self::blank_line_comments(),ModuleDef =>
                    
                        &[
                                ";",
                        ],
                    MoonScript =>
                    
                        &[
                                "--",
                        ],
                    MsBuild =>
                    
                        
                            Self::html_line_comments(),
                        Mustache =>
                    
                        
                            Self::blank_line_comments(),Nim =>
                    
                        
                            Self::hash_line_comments(),
                        Nix =>
                    
                        &[
                                "#",
                        ],
                    NotQuitePerl =>
                    
                        &[
                                "#",
                        ],
                    OCaml =>
                    
                        
                            Self::func_line_comments(),
                        ObjectiveC =>
                    
                        
                            Self::c_line_comments(),
                        ObjectiveCpp =>
                    
                        
                            Self::c_line_comments(),
                        Odin =>
                    
                        &[
                                "//",
                        ],
                    Org =>
                    
                        &[
                                "# ",
                        ],
                    Oz =>
                    
                        
                            Self::pro_line_comments(),
                        PSL =>
                    
                        
                            Self::c_line_comments(),
                        Pascal =>
                    
                        &[
                                "//",
                        ],
                    Perl =>
                    
                        &[
                                "#",
                        ],
                    Perl6 =>
                    
                        &[
                                "#",
                        ],
                    Pest =>
                    
                        &[
                                "//",
                        ],
                    Php =>
                    
                        &[
                                "#",
                                "//",
                        ],
                    Polly =>
                    
                        
                            Self::html_line_comments(),
                        Pony =>
                    
                        
                            Self::c_line_comments(),
                        PostCss =>
                    
                        
                            Self::c_line_comments(),
                        PowerShell =>
                    
                        &[
                                "#",
                        ],
                    Processing =>
                    
                        
                            Self::c_line_comments(),
                        Prolog =>
                    
                        
                            Self::pro_line_comments(),
                        Protobuf =>
                    
                        &[
                                "//",
                        ],
                    PureScript =>
                    
                        
                            Self::haskell_line_comments(),
                        Python =>
                    
                        
                            Self::hash_line_comments(),
                        Qcl =>
                    
                        
                            Self::c_line_comments(),
                        Qml =>
                    
                        
                            Self::c_line_comments(),
                        R =>
                    
                        
                            Self::hash_line_comments(),
                        RON =>
                    
                        
                            Self::c_line_comments(),
                        RPMSpecfile =>
                    
                        
                            Self::hash_line_comments(),
                        Racket =>
                    
                        &[
                                ";",
                        ],
                    Rakefile =>
                    
                        &[
                                "#",
                        ],
                    Razor =>
                    
                        
                            Self::blank_line_comments(),ReStructuredText =>
                    
                        
                            Self::blank_line_comments(),Ruby =>
                    
                        &[
                                "#",
                        ],
                    RubyHtml =>
                    
                        
                            Self::html_line_comments(),
                        Rust =>
                    
                        
                            Self::c_line_comments(),
                        SRecode =>
                    
                        &[
                                ";;",
                        ],
                    Sass =>
                    
                        
                            Self::c_line_comments(),
                        Scala =>
                    
                        
                            Self::c_line_comments(),
                        Scheme =>
                    
                        &[
                                ";",
                        ],
                    Scons =>
                    
                        
                            Self::hash_line_comments(),
                        Sh =>
                    
                        
                            Self::hash_line_comments(),
                        Sml =>
                    
                        
                            Self::func_line_comments(),
                        Solidity =>
                    
                        
                            Self::c_line_comments(),
                        SpecmanE =>
                    
                        &[
                                "--",
                                "//",
                        ],
                    Spice =>
                    
                        &[
                                "*",
                        ],
                    Sql =>
                    
                        &[
                                "--",
                        ],
                    Stratego =>
                    
                        
                            Self::c_line_comments(),
                        Svg =>
                    
                        
                            Self::html_line_comments(),
                        Swift =>
                    
                        
                            Self::c_line_comments(),
                        Swig =>
                    
                        
                            Self::c_line_comments(),
                        SystemVerilog =>
                    
                        
                            Self::c_line_comments(),
                        Tcl =>
                    
                        
                            Self::hash_line_comments(),
                        Tex =>
                    
                        &[
                                "%",
                        ],
                    Text =>
                    
                        
                            Self::blank_line_comments(),Thrift =>
                    
                        &[
                                "#",
                                "//",
                        ],
                    Toml =>
                    
                        
                            Self::hash_line_comments(),
                        Twig =>
                    
                        
                            Self::html_line_comments(),
                        TypeScript =>
                    
                        
                            Self::c_line_comments(),
                        UnrealDeveloperMarkdown =>
                    
                        
                            Self::blank_line_comments(),UnrealPlugin =>
                    
                        
                            Self::blank_line_comments(),
                        UnrealProject =>
                    
                        
                            Self::blank_line_comments(),
                        UnrealScript =>
                    
                        
                            Self::c_line_comments(),
                        UnrealShader =>
                    
                        
                            Self::c_line_comments(),
                        UnrealShaderHeader =>
                    
                        
                            Self::c_line_comments(),
                        UrWeb =>
                    
                        
                            Self::func_line_comments(),
                        UrWebProject =>
                    
                        &[
                                "#",
                        ],
                    VB6 =>
                    
                        &[
                                "'",
                        ],
                    VBScript =>
                    
                        &[
                                "'",
                                "REM",
                        ],
                    Vala =>
                    
                        
                            Self::c_line_comments(),
                        Verilog =>
                    
                        
                            Self::c_line_comments(),
                        VerilogArgsFile =>
                    
                        
                            Self::blank_line_comments(),Vhdl =>
                    
                        &[
                                "--",
                        ],
                    VimScript =>
                    
                        &[
                                "\"",
                        ],
                    VisualBasic =>
                    
                        &[
                                "'",
                        ],
                    VisualStudioProject =>
                    
                        
                            Self::html_line_comments(),
                        VisualStudioSolution =>
                    
                        
                            Self::blank_line_comments(),
                        Vue =>
                    
                        
                            Self::html_line_comments(),
                        WebAssembly =>
                    
                        &[
                                ";;",
                        ],
                    Wolfram =>
                    
                        
                            Self::func_line_comments(),
                        XSL =>
                    
                        
                            Self::html_line_comments(),
                        Xaml =>
                    
                        
                            Self::html_line_comments(),
                        XcodeConfig =>
                    
                        &[
                                "//",
                        ],
                    Xml =>
                    
                        
                            Self::html_line_comments(),
                        Xtend =>
                    
                        
                            Self::c_line_comments(),
                        Yaml =>
                    
                        
                            Self::hash_line_comments(),
                        Zig =>
                    
                        &[
                                "//",
                        ],
                    Zsh =>
                    
                        
                            Self::hash_line_comments(),
                        
        }
    }

    /// Returns the single line comments of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Rust;
    /// assert_eq!(lang.multi_line_comments(), &[("/*", "*/")]);
    /// ```
    pub fn multi_line_comments(self) -> &'static [(&'static str, &'static str)]
    {
        match self {
            Abap =>
                    
                        
                            Self::blank_multi_line_comments(),ActionScript =>
                    
                        
                            Self::c_multi_line_comments(),
                        Ada =>
                    
                        
                            Self::blank_multi_line_comments(),Agda =>
                    
                        
                            Self::haskell_multi_line_comments(),
                        Alex =>
                    
                        
                            Self::blank_multi_line_comments(),Asn1 =>
                    
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Asp =>
                    
                        
                            Self::blank_multi_line_comments(),AspNet =>
                    
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "<%--",
                                    "-->",
                                ),
                        ],
                    Assembly =>
                    
                        
                            Self::blank_multi_line_comments(),AutoHotKey =>
                    
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Autoconf =>
                    
                        
                            Self::blank_multi_line_comments(),Automake =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Bash =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Batch =>
                    
                        
                            Self::blank_multi_line_comments(),BrightScript =>
                    
                        
                            Self::blank_multi_line_comments(),C =>
                    
                        
                            Self::c_multi_line_comments(),
                        CHeader =>
                    
                        
                            Self::c_multi_line_comments(),
                        CMake =>
                    
                        
                            Self::blank_multi_line_comments(),CSharp =>
                    
                        
                            Self::c_multi_line_comments(),
                        CShell =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Cabal =>
                    
                        
                            Self::haskell_multi_line_comments(),
                        Cassius =>
                    
                        
                            Self::c_multi_line_comments(),
                        Ceylon =>
                    
                        
                            Self::c_multi_line_comments(),
                        Clojure =>
                    
                        
                            Self::blank_multi_line_comments(),ClojureC =>
                    
                        
                            Self::blank_multi_line_comments(),ClojureScript =>
                    
                        
                            Self::blank_multi_line_comments(),Cobol =>
                    
                        
                            Self::blank_multi_line_comments(),CoffeeScript =>
                    
                        &[
                                (
                                    "###",
                                    "###",
                                ),
                        ],
                    Cogent =>
                    
                        
                            Self::blank_multi_line_comments(),ColdFusion =>
                    
                        &[
                                (
                                    "<!---",
                                    "--->",
                                ),
                        ],
                    ColdFusionScript =>
                    
                        
                            Self::c_multi_line_comments(),
                        Coq =>
                    
                        
                            Self::func_multi_line_comments(),
                        Cpp =>
                    
                        
                            Self::c_multi_line_comments(),
                        CppHeader =>
                    
                        
                            Self::c_multi_line_comments(),
                        Crystal =>
                    
                        
                            Self::blank_multi_line_comments(),Css =>
                    
                        
                            Self::c_multi_line_comments(),
                        D =>
                    
                        
                            Self::c_multi_line_comments(),
                        Dart =>
                    
                        
                            Self::c_multi_line_comments(),
                        DeviceTree =>
                    
                        
                            Self::c_multi_line_comments(),
                        Dockerfile =>
                    
                        
                            Self::blank_multi_line_comments(),DotNetResource =>
                    
                        
                            Self::html_multi_line_comments(),
                        DreamMaker =>
                    
                        
                            Self::c_multi_line_comments(),
                        Edn =>
                    
                        
                            Self::blank_multi_line_comments(),Elisp =>
                    
                        
                            Self::blank_multi_line_comments(),Elixir =>
                    
                        
                            Self::blank_multi_line_comments(),Elm =>
                    
                        
                            Self::haskell_multi_line_comments(),
                        Elvish =>
                    
                        
                            Self::hash_multi_line_comments(),
                        EmacsDevEnv =>
                    
                        
                            Self::blank_multi_line_comments(),Emojicode =>
                    
                        &[
                                (
                                    "💭🔜",
                                    "🔚💭",
                                ),
                                (
                                    "📗",
                                    "📗",
                                ),
                                (
                                    "📘",
                                    "📘",
                                ),
                        ],
                    Erlang =>
                    
                        
                            Self::blank_multi_line_comments(),FEN =>
                    
                        
                            Self::blank_multi_line_comments(),FSharp =>
                    
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    Fish =>
                    
                        
                            Self::hash_multi_line_comments(),
                        FlatBuffers =>
                    
                        
                            Self::c_multi_line_comments(),
                        Forth =>
                    
                        &[
                                (
                                    "( ",
                                    ")",
                                ),
                        ],
                    FortranLegacy =>
                    
                        
                            Self::blank_multi_line_comments(),FortranModern =>
                    
                        
                            Self::blank_multi_line_comments(),Fstar =>
                    
                        
                            Self::func_multi_line_comments(),
                        GdScript =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Glsl =>
                    
                        
                            Self::c_multi_line_comments(),
                        Go =>
                    
                        
                            Self::c_multi_line_comments(),
                        Graphql =>
                    
                        
                            Self::blank_multi_line_comments(),Groovy =>
                    
                        
                            Self::c_multi_line_comments(),
                        Hamlet =>
                    
                        
                            Self::html_multi_line_comments(),
                        Handlebars =>
                    
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "{{!",
                                    "}}",
                                ),
                        ],
                    Happy =>
                    
                        
                            Self::blank_multi_line_comments(),Haskell =>
                    
                        
                            Self::haskell_multi_line_comments(),
                        Haxe =>
                    
                        
                            Self::c_multi_line_comments(),
                        Hcl =>
                    
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Hex =>
                    
                        
                            Self::blank_multi_line_comments(),Hlsl =>
                    
                        
                            Self::c_multi_line_comments(),
                        HolyC =>
                    
                        
                            Self::c_multi_line_comments(),
                        Html =>
                    
                        
                            Self::html_multi_line_comments(),
                        Idris =>
                    
                        
                            Self::haskell_multi_line_comments(),
                        Ini =>
                    
                        
                            Self::blank_multi_line_comments(),IntelHex =>
                    
                        
                            Self::blank_multi_line_comments(),Isabelle =>
                    
                        &[
                                (
                                    "\\<open>",
                                    "\\<close>",
                                ),
                                (
                                    "‹",
                                    "›",
                                ),
                                (
                                    "{*",
                                    "*}",
                                ),
                                (
                                    "(*",
                                    "*)",
                                ),
                        ],
                    Jai =>
                    
                        
                            Self::c_multi_line_comments(),
                        Java =>
                    
                        
                            Self::c_multi_line_comments(),
                        JavaScript =>
                    
                        
                            Self::c_multi_line_comments(),
                        Json =>
                    
                        
                            Self::blank_multi_line_comments(),Jsx =>
                    
                        
                            Self::c_multi_line_comments(),
                        Julia =>
                    
                        &[
                                (
                                    "#=",
                                    "=#",
                                ),
                        ],
                    Julius =>
                    
                        
                            Self::c_multi_line_comments(),
                        KakouneScript =>
                    
                        
                            Self::blank_multi_line_comments(),Kotlin =>
                    
                        
                            Self::c_multi_line_comments(),
                        LLVM =>
                    
                        
                            Self::blank_multi_line_comments(),Lean =>
                    
                        &[
                                (
                                    "/-",
                                    "-/",
                                ),
                        ],
                    Less =>
                    
                        
                            Self::c_multi_line_comments(),
                        LinkerScript =>
                    
                        
                            Self::c_multi_line_comments(),
                        Liquid =>
                    
                        &[
                                (
                                    "{% comment %}",
                                    "{% endcomment %}",
                                ),
                        ],
                    Lisp =>
                    
                        &[
                                (
                                    "#|",
                                    "|#",
                                ),
                        ],
                    Logtalk =>
                    
                        
                            Self::pro_multi_line_comments(),
                        Lua =>
                    
                        &[
                                (
                                    "--[[",
                                    "]]",
                                ),
                        ],
                    Lucius =>
                    
                        
                            Self::c_multi_line_comments(),
                        Madlang =>
                    
                        &[
                                (
                                    "{#",
                                    "#}",
                                ),
                        ],
                    Makefile =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Markdown =>
                    
                        
                            Self::blank_multi_line_comments(),Meson =>
                    
                        
                            Self::blank_multi_line_comments(),Mint =>
                    
                        
                            Self::blank_multi_line_comments(),ModuleDef =>
                    
                        
                            Self::blank_multi_line_comments(),MoonScript =>
                    
                        
                            Self::blank_multi_line_comments(),MsBuild =>
                    
                        
                            Self::html_multi_line_comments(),
                        Mustache =>
                    
                        &[
                                (
                                    "{{!",
                                    "}}",
                                ),
                        ],
                    Nim =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Nix =>
                    
                        
                            Self::c_multi_line_comments(),
                        NotQuitePerl =>
                    
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    OCaml =>
                    
                        
                            Self::func_multi_line_comments(),
                        ObjectiveC =>
                    
                        
                            Self::c_multi_line_comments(),
                        ObjectiveCpp =>
                    
                        
                            Self::c_multi_line_comments(),
                        Odin =>
                    
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Org =>
                    
                        
                            Self::blank_multi_line_comments(),Oz =>
                    
                        
                            Self::pro_multi_line_comments(),
                        PSL =>
                    
                        
                            Self::c_multi_line_comments(),
                        Pascal =>
                    
                        &[
                                (
                                    "(*",
                                    "*)",
                                ),
                                (
                                    "{",
                                    "}",
                                ),
                        ],
                    Perl =>
                    
                        &[
                                (
                                    "=pod",
                                    "=cut",
                                ),
                        ],
                    Perl6 =>
                    
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    Pest =>
                    
                        
                            Self::blank_multi_line_comments(),Php =>
                    
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Polly =>
                    
                        
                            Self::html_multi_line_comments(),
                        Pony =>
                    
                        
                            Self::c_multi_line_comments(),
                        PostCss =>
                    
                        
                            Self::c_multi_line_comments(),
                        PowerShell =>
                    
                        &[
                                (
                                    "<#",
                                    "#>",
                                ),
                        ],
                    Processing =>
                    
                        
                            Self::c_multi_line_comments(),
                        Prolog =>
                    
                        
                            Self::pro_multi_line_comments(),
                        Protobuf =>
                    
                        
                            Self::blank_multi_line_comments(),PureScript =>
                    
                        
                            Self::haskell_multi_line_comments(),
                        Python =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Qcl =>
                    
                        
                            Self::c_multi_line_comments(),
                        Qml =>
                    
                        
                            Self::c_multi_line_comments(),
                        R =>
                    
                        
                            Self::hash_multi_line_comments(),
                        RON =>
                    
                        
                            Self::c_multi_line_comments(),
                        RPMSpecfile =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Racket =>
                    
                        &[
                                (
                                    "#|",
                                    "|#",
                                ),
                        ],
                    Rakefile =>
                    
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    Razor =>
                    
                        &[
                                (
                                    "<!--",
                                    "-->",
                                ),
                                (
                                    "@*",
                                    "*@",
                                ),
                        ],
                    ReStructuredText =>
                    
                        
                            Self::blank_multi_line_comments(),Ruby =>
                    
                        &[
                                (
                                    "=begin",
                                    "=end",
                                ),
                        ],
                    RubyHtml =>
                    
                        
                            Self::html_multi_line_comments(),
                        Rust =>
                    
                        
                            Self::c_multi_line_comments(),
                        SRecode =>
                    
                        
                            Self::blank_multi_line_comments(),Sass =>
                    
                        
                            Self::c_multi_line_comments(),
                        Scala =>
                    
                        
                            Self::c_multi_line_comments(),
                        Scheme =>
                    
                        &[
                                (
                                    "#|",
                                    "|#",
                                ),
                        ],
                    Scons =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Sh =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Sml =>
                    
                        
                            Self::func_multi_line_comments(),
                        Solidity =>
                    
                        
                            Self::c_multi_line_comments(),
                        SpecmanE =>
                    
                        &[
                                (
                                    "'>",
                                    "<'",
                                ),
                        ],
                    Spice =>
                    
                        
                            Self::blank_multi_line_comments(),Sql =>
                    
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Stratego =>
                    
                        
                            Self::c_multi_line_comments(),
                        Svg =>
                    
                        
                            Self::html_multi_line_comments(),
                        Swift =>
                    
                        
                            Self::c_multi_line_comments(),
                        Swig =>
                    
                        
                            Self::c_multi_line_comments(),
                        SystemVerilog =>
                    
                        
                            Self::c_multi_line_comments(),
                        Tcl =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Tex =>
                    
                        
                            Self::blank_multi_line_comments(),Text =>
                    
                        
                            Self::blank_multi_line_comments(),Thrift =>
                    
                        &[
                                (
                                    "/*",
                                    "*/",
                                ),
                        ],
                    Toml =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Twig =>
                    
                        &[
                                (
                                    "{#",
                                    "#}",
                                ),
                        ],
                    TypeScript =>
                    
                        
                            Self::c_multi_line_comments(),
                        UnrealDeveloperMarkdown =>
                    
                        
                            Self::blank_multi_line_comments(),UnrealPlugin =>
                    
                        
                            Self::blank_multi_line_comments(),
                        UnrealProject =>
                    
                        
                            Self::blank_multi_line_comments(),
                        UnrealScript =>
                    
                        
                            Self::c_multi_line_comments(),
                        UnrealShader =>
                    
                        
                            Self::c_multi_line_comments(),
                        UnrealShaderHeader =>
                    
                        
                            Self::c_multi_line_comments(),
                        UrWeb =>
                    
                        
                            Self::func_multi_line_comments(),
                        UrWebProject =>
                    
                        
                            Self::blank_multi_line_comments(),VB6 =>
                    
                        
                            Self::blank_multi_line_comments(),VBScript =>
                    
                        
                            Self::blank_multi_line_comments(),Vala =>
                    
                        
                            Self::c_multi_line_comments(),
                        Verilog =>
                    
                        
                            Self::c_multi_line_comments(),
                        VerilogArgsFile =>
                    
                        
                            Self::blank_multi_line_comments(),Vhdl =>
                    
                        
                            Self::blank_multi_line_comments(),VimScript =>
                    
                        
                            Self::blank_multi_line_comments(),VisualBasic =>
                    
                        
                            Self::blank_multi_line_comments(),VisualStudioProject =>
                    
                        
                            Self::html_multi_line_comments(),
                        VisualStudioSolution =>
                    
                        
                            Self::blank_multi_line_comments(),
                        Vue =>
                    
                        
                            Self::html_multi_line_comments(),
                        WebAssembly =>
                    
                        
                            Self::blank_multi_line_comments(),Wolfram =>
                    
                        
                            Self::func_multi_line_comments(),
                        XSL =>
                    
                        
                            Self::html_multi_line_comments(),
                        Xaml =>
                    
                        
                            Self::html_multi_line_comments(),
                        XcodeConfig =>
                    
                        
                            Self::blank_multi_line_comments(),Xml =>
                    
                        
                            Self::html_multi_line_comments(),
                        Xtend =>
                    
                        
                            Self::c_multi_line_comments(),
                        Yaml =>
                    
                        
                            Self::hash_multi_line_comments(),
                        Zig =>
                    
                        
                            Self::blank_multi_line_comments(),Zsh =>
                    
                        
                            Self::hash_multi_line_comments(),
                        
        }
    }


    /// Returns whether the language allows nested multi line comments.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Rust;
    /// assert!(lang.allows_nested());
    /// ```
    pub fn allows_nested(self) -> bool {
        match self {
            Abap =>
                            false,ActionScript =>
                                Self::c_allows_nested()
                    ,Ada =>
                            false,Agda =>
                                Self::haskell_allows_nested()
                    ,Alex =>
                            false,Asn1 =>
                            false,Asp =>
                            false,AspNet =>
                            false,Assembly =>
                            false,AutoHotKey =>
                            false,Autoconf =>
                            false,Automake =>
                                Self::hash_allows_nested()
                    ,Bash =>
                                Self::hash_allows_nested()
                    ,Batch =>
                            false,BrightScript =>
                            false,C =>
                                Self::c_allows_nested()
                    ,CHeader =>
                                Self::c_allows_nested()
                    ,CMake =>
                            false,CSharp =>
                                Self::c_allows_nested()
                    ,CShell =>
                                Self::hash_allows_nested()
                    ,Cabal =>
                                Self::haskell_allows_nested()
                    ,Cassius =>
                                Self::c_allows_nested()
                    ,Ceylon =>
                                Self::c_allows_nested()
                    ,Clojure =>
                            false,ClojureC =>
                            false,ClojureScript =>
                            false,Cobol =>
                            false,CoffeeScript =>
                            false,Cogent =>
                            false,ColdFusion =>
                            false,ColdFusionScript =>
                                Self::c_allows_nested()
                    ,Coq =>
                                Self::func_allows_nested()
                    ,Cpp =>
                                Self::c_allows_nested()
                    ,CppHeader =>
                                Self::c_allows_nested()
                    ,Crystal =>
                            false,Css =>
                                Self::c_allows_nested()
                    ,D =>
                                Self::c_allows_nested()
                    ,Dart =>
                                Self::c_allows_nested()
                    ,DeviceTree =>
                                Self::c_allows_nested()
                    ,Dockerfile =>
                            false,DotNetResource =>
                                Self::html_allows_nested()
                    ,DreamMaker =>
                            true
                        
                    ,Edn =>
                            false,Elisp =>
                            false,Elixir =>
                            false,Elm =>
                                Self::haskell_allows_nested()
                    ,Elvish =>
                                Self::hash_allows_nested()
                    ,EmacsDevEnv =>
                            false,Emojicode =>
                            false,Erlang =>
                            false,FEN =>
                            false,FSharp =>
                            false,Fish =>
                                Self::hash_allows_nested()
                    ,FlatBuffers =>
                                Self::c_allows_nested()
                    ,Forth =>
                            false,FortranLegacy =>
                            false,FortranModern =>
                            false,Fstar =>
                                Self::func_allows_nested()
                    ,GdScript =>
                                Self::hash_allows_nested()
                    ,Glsl =>
                                Self::c_allows_nested()
                    ,Go =>
                                Self::c_allows_nested()
                    ,Graphql =>
                            false,Groovy =>
                                Self::c_allows_nested()
                    ,Hamlet =>
                                Self::html_allows_nested()
                    ,Handlebars =>
                            false,Happy =>
                            false,Haskell =>
                                Self::haskell_allows_nested()
                    ,Haxe =>
                                Self::c_allows_nested()
                    ,Hcl =>
                            false,Hex =>
                            false,Hlsl =>
                                Self::c_allows_nested()
                    ,HolyC =>
                                Self::c_allows_nested()
                    ,Html =>
                                Self::html_allows_nested()
                    ,Idris =>
                            true
                        
                    ,Ini =>
                            false,IntelHex =>
                            false,Isabelle =>
                            false,Jai =>
                            true
                        
                    ,Java =>
                                Self::c_allows_nested()
                    ,JavaScript =>
                                Self::c_allows_nested()
                    ,Json =>
                            false,Jsx =>
                                Self::c_allows_nested()
                    ,Julia =>
                            true
                        ,Julius =>
                                Self::c_allows_nested()
                    ,KakouneScript =>
                            false,Kotlin =>
                            true
                        
                    ,LLVM =>
                            false,Lean =>
                            true
                        ,Less =>
                                Self::c_allows_nested()
                    ,LinkerScript =>
                                Self::c_allows_nested()
                    ,Liquid =>
                                Self::html_allows_nested()
                    ,Lisp =>
                            true
                        ,Logtalk =>
                                Self::pro_allows_nested()
                    ,Lua =>
                            false,Lucius =>
                                Self::c_allows_nested()
                    ,Madlang =>
                            false,Makefile =>
                                Self::hash_allows_nested()
                    ,Markdown =>
                            false,Meson =>
                            false,Mint =>
                            false,ModuleDef =>
                            false,MoonScript =>
                            false,MsBuild =>
                                Self::html_allows_nested()
                    ,Mustache =>
                            false,Nim =>
                                Self::hash_allows_nested()
                    ,Nix =>
                                Self::c_allows_nested()
                    ,NotQuitePerl =>
                            false,OCaml =>
                                Self::func_allows_nested()
                    ,ObjectiveC =>
                                Self::c_allows_nested()
                    ,ObjectiveCpp =>
                                Self::c_allows_nested()
                    ,Odin =>
                            false,Org =>
                            false,Oz =>
                                Self::pro_allows_nested()
                    ,PSL =>
                                Self::c_allows_nested()
                    ,Pascal =>
                            true
                        ,Perl =>
                            false,Perl6 =>
                            false,Pest =>
                            false,Php =>
                            false,Polly =>
                                Self::html_allows_nested()
                    ,Pony =>
                                Self::c_allows_nested()
                    ,PostCss =>
                                Self::c_allows_nested()
                    ,PowerShell =>
                            false,Processing =>
                                Self::c_allows_nested()
                    ,Prolog =>
                                Self::pro_allows_nested()
                    ,Protobuf =>
                            false,PureScript =>
                                Self::haskell_allows_nested()
                    ,Python =>
                                Self::hash_allows_nested()
                    ,Qcl =>
                                Self::c_allows_nested()
                    ,Qml =>
                                Self::c_allows_nested()
                    ,R =>
                                Self::hash_allows_nested()
                    ,RON =>
                            true
                        
                    ,RPMSpecfile =>
                                Self::hash_allows_nested()
                    ,Racket =>
                            true
                        ,Rakefile =>
                            false,Razor =>
                            false,ReStructuredText =>
                            false,Ruby =>
                            false,RubyHtml =>
                                Self::html_allows_nested()
                    ,Rust =>
                            true
                        
                    ,SRecode =>
                            false,Sass =>
                                Self::c_allows_nested()
                    ,Scala =>
                                Self::c_allows_nested()
                    ,Scheme =>
                            true
                        ,Scons =>
                                Self::hash_allows_nested()
                    ,Sh =>
                                Self::hash_allows_nested()
                    ,Sml =>
                                Self::func_allows_nested()
                    ,Solidity =>
                                Self::c_allows_nested()
                    ,SpecmanE =>
                            false,Spice =>
                            false,Sql =>
                            false,Stratego =>
                                Self::c_allows_nested()
                    ,Svg =>
                                Self::html_allows_nested()
                    ,Swift =>
                            true
                        
                    ,Swig =>
                            true
                        
                    ,SystemVerilog =>
                                Self::c_allows_nested()
                    ,Tcl =>
                                Self::hash_allows_nested()
                    ,Tex =>
                            false,Text =>
                            false,Thrift =>
                            false,Toml =>
                                Self::hash_allows_nested()
                    ,Twig =>
                                Self::html_allows_nested()
                    ,TypeScript =>
                                Self::c_allows_nested()
                    ,UnrealDeveloperMarkdown =>
                            false,UnrealPlugin =>
                                Self::blank_allows_nested()
                    ,UnrealProject =>
                                Self::blank_allows_nested()
                    ,UnrealScript =>
                                Self::c_allows_nested()
                    ,UnrealShader =>
                                Self::c_allows_nested()
                    ,UnrealShaderHeader =>
                                Self::c_allows_nested()
                    ,UrWeb =>
                                Self::func_allows_nested()
                    ,UrWebProject =>
                            false,VB6 =>
                            false,VBScript =>
                            false,Vala =>
                                Self::c_allows_nested()
                    ,Verilog =>
                                Self::c_allows_nested()
                    ,VerilogArgsFile =>
                            false,Vhdl =>
                            false,VimScript =>
                            false,VisualBasic =>
                            false,VisualStudioProject =>
                                Self::html_allows_nested()
                    ,VisualStudioSolution =>
                                Self::blank_allows_nested()
                    ,Vue =>
                                Self::html_allows_nested()
                    ,WebAssembly =>
                            false,Wolfram =>
                                Self::func_allows_nested()
                    ,XSL =>
                                Self::html_allows_nested()
                    ,Xaml =>
                                Self::html_allows_nested()
                    ,XcodeConfig =>
                            false,Xml =>
                                Self::html_allows_nested()
                    ,Xtend =>
                                Self::c_allows_nested()
                    ,Yaml =>
                                Self::hash_allows_nested()
                    ,Zig =>
                            false,Zsh =>
                                Self::hash_allows_nested()
                    ,
        }
    }

    /// Returns what nested comments the language has. (Currently only D has
    /// any of this type.)
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::D;
    /// assert_eq!(lang.nested_comments(), &[("/+", "+/")]);
    /// ```
    pub fn nested_comments(self) -> &'static [(&'static str, &'static str)]
    {
        match self {
            Abap => &[
                ],ActionScript => &[
                ],Ada => &[
                ],Agda => &[
                ],Alex => &[
                ],Asn1 => &[
                ],Asp => &[
                ],AspNet => &[
                ],Assembly => &[
                ],AutoHotKey => &[
                ],Autoconf => &[
                ],Automake => &[
                ],Bash => &[
                ],Batch => &[
                ],BrightScript => &[
                ],C => &[
                ],CHeader => &[
                ],CMake => &[
                ],CSharp => &[
                ],CShell => &[
                ],Cabal => &[
                ],Cassius => &[
                ],Ceylon => &[
                ],Clojure => &[
                ],ClojureC => &[
                ],ClojureScript => &[
                ],Cobol => &[
                ],CoffeeScript => &[
                ],Cogent => &[
                ],ColdFusion => &[
                ],ColdFusionScript => &[
                ],Coq => &[
                ],Cpp => &[
                ],CppHeader => &[
                ],Crystal => &[
                ],Css => &[
                ],D => &[
                    ( "/+", "+/",
                    ),
                ],Dart => &[
                ],DeviceTree => &[
                ],Dockerfile => &[
                ],DotNetResource => &[
                ],DreamMaker => &[
                ],Edn => &[
                ],Elisp => &[
                ],Elixir => &[
                ],Elm => &[
                ],Elvish => &[
                ],EmacsDevEnv => &[
                ],Emojicode => &[
                ],Erlang => &[
                ],FEN => &[
                ],FSharp => &[
                ],Fish => &[
                ],FlatBuffers => &[
                ],Forth => &[
                ],FortranLegacy => &[
                ],FortranModern => &[
                ],Fstar => &[
                ],GdScript => &[
                ],Glsl => &[
                ],Go => &[
                ],Graphql => &[
                ],Groovy => &[
                ],Hamlet => &[
                ],Handlebars => &[
                ],Happy => &[
                ],Haskell => &[
                ],Haxe => &[
                ],Hcl => &[
                ],Hex => &[
                ],Hlsl => &[
                ],HolyC => &[
                ],Html => &[
                ],Idris => &[
                ],Ini => &[
                ],IntelHex => &[
                ],Isabelle => &[
                ],Jai => &[
                ],Java => &[
                ],JavaScript => &[
                ],Json => &[
                ],Jsx => &[
                ],Julia => &[
                ],Julius => &[
                ],KakouneScript => &[
                ],Kotlin => &[
                ],LLVM => &[
                ],Lean => &[
                ],Less => &[
                ],LinkerScript => &[
                ],Liquid => &[
                ],Lisp => &[
                ],Logtalk => &[
                ],Lua => &[
                ],Lucius => &[
                ],Madlang => &[
                ],Makefile => &[
                ],Markdown => &[
                ],Meson => &[
                ],Mint => &[
                ],ModuleDef => &[
                ],MoonScript => &[
                ],MsBuild => &[
                ],Mustache => &[
                ],Nim => &[
                ],Nix => &[
                ],NotQuitePerl => &[
                ],OCaml => &[
                ],ObjectiveC => &[
                ],ObjectiveCpp => &[
                ],Odin => &[
                ],Org => &[
                ],Oz => &[
                ],PSL => &[
                ],Pascal => &[
                ],Perl => &[
                ],Perl6 => &[
                ],Pest => &[
                ],Php => &[
                ],Polly => &[
                ],Pony => &[
                ],PostCss => &[
                ],PowerShell => &[
                ],Processing => &[
                ],Prolog => &[
                ],Protobuf => &[
                ],PureScript => &[
                ],Python => &[
                ],Qcl => &[
                ],Qml => &[
                ],R => &[
                ],RON => &[
                ],RPMSpecfile => &[
                ],Racket => &[
                ],Rakefile => &[
                ],Razor => &[
                ],ReStructuredText => &[
                ],Ruby => &[
                ],RubyHtml => &[
                ],Rust => &[
                ],SRecode => &[
                ],Sass => &[
                ],Scala => &[
                ],Scheme => &[
                ],Scons => &[
                ],Sh => &[
                ],Sml => &[
                ],Solidity => &[
                ],SpecmanE => &[
                ],Spice => &[
                ],Sql => &[
                ],Stratego => &[
                ],Svg => &[
                ],Swift => &[
                ],Swig => &[
                ],SystemVerilog => &[
                ],Tcl => &[
                ],Tex => &[
                ],Text => &[
                ],Thrift => &[
                ],Toml => &[
                ],Twig => &[
                ],TypeScript => &[
                ],UnrealDeveloperMarkdown => &[
                ],UnrealPlugin => &[
                ],UnrealProject => &[
                ],UnrealScript => &[
                ],UnrealShader => &[
                ],UnrealShaderHeader => &[
                ],UrWeb => &[
                ],UrWebProject => &[
                ],VB6 => &[
                ],VBScript => &[
                ],Vala => &[
                ],Verilog => &[
                ],VerilogArgsFile => &[
                ],Vhdl => &[
                ],VimScript => &[
                ],VisualBasic => &[
                ],VisualStudioProject => &[
                ],VisualStudioSolution => &[
                ],Vue => &[
                ],WebAssembly => &[
                ],Wolfram => &[
                ],XSL => &[
                ],Xaml => &[
                ],XcodeConfig => &[
                ],Xml => &[
                ],Xtend => &[
                ],Yaml => &[
                ],Zig => &[
                ],Zsh => &[
                ],
        }
    }

    /// Returns the quotes of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Rust;
    /// assert_eq!(lang.quotes(), &[("r#\"", "\"#"), ("#\"", "\"#"), ("\"", "\"")]);
    /// ```
    pub fn quotes(self) -> &'static [(&'static str, &'static str)] {
        match self {
            Abap =>
                    
                        
                            Self::blank_quotes(),ActionScript =>
                    
                        
                            Self::c_quotes(),
                        Ada =>
                    
                        
                            Self::blank_quotes(),Agda =>
                    
                        
                            Self::haskell_quotes(),
                        Alex =>
                    
                        
                            Self::blank_quotes(),Asn1 =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Asp =>
                    
                        
                            Self::blank_quotes(),AspNet =>
                    
                        
                            Self::blank_quotes(),Assembly =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    AutoHotKey =>
                    
                        
                            Self::blank_quotes(),Autoconf =>
                    
                        
                            Self::blank_quotes(),Automake =>
                    
                        
                            Self::hash_quotes(),
                        Bash =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Batch =>
                    
                        
                            Self::blank_quotes(),BrightScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    C =>
                    
                        
                            Self::c_quotes(),
                        CHeader =>
                    
                        
                            Self::c_quotes(),
                        CMake =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    CSharp =>
                    
                        
                            Self::c_quotes(),
                        CShell =>
                    
                        
                            Self::hash_quotes(),
                        Cabal =>
                    
                        
                            Self::haskell_quotes(),
                        Cassius =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Ceylon =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Clojure =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    ClojureC =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    ClojureScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Cobol =>
                    
                        
                            Self::blank_quotes(),CoffeeScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Cogent =>
                    
                        
                            Self::blank_quotes(),ColdFusion =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    ColdFusionScript =>
                    
                        
                            Self::c_quotes(),
                        Coq =>
                    
                        
                            Self::func_quotes(),
                        Cpp =>
                    
                        
                            Self::c_quotes(),
                        CppHeader =>
                    
                        
                            Self::c_quotes(),
                        Crystal =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Css =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    D =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Dart =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "'''",
                                    "'''",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    DeviceTree =>
                    
                        
                            Self::c_quotes(),
                        Dockerfile =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    DotNetResource =>
                    
                        
                            Self::html_quotes(),
                        DreamMaker =>
                    
                        &[
                                (
                                    "{\"",
                                    "\"}",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Edn =>
                    
                        
                            Self::blank_quotes(),Elisp =>
                    
                        
                            Self::blank_quotes(),Elixir =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "'''",
                                    "'''",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Elm =>
                    
                        
                            Self::haskell_quotes(),
                        Elvish =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    EmacsDevEnv =>
                    
                        
                            Self::blank_quotes(),Emojicode =>
                    
                        &[
                                (
                                    "❌🔤",
                                    "❌🔤",
                                ),
                        ],
                    Erlang =>
                    
                        
                            Self::blank_quotes(),FEN =>
                    
                        
                            Self::blank_quotes(),FSharp =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Fish =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    FlatBuffers =>
                    
                        
                            Self::c_quotes(),
                        Forth =>
                    
                        
                            Self::blank_quotes(),FortranLegacy =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    FortranModern =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Fstar =>
                    
                        
                            Self::func_quotes(),
                        GdScript =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Glsl =>
                    
                        
                            Self::c_quotes(),
                        Go =>
                    
                        
                            Self::c_quotes(),
                        Graphql =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Groovy =>
                    
                        
                            Self::c_quotes(),
                        Hamlet =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Handlebars =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Happy =>
                    
                        
                            Self::blank_quotes(),Haskell =>
                    
                        
                            Self::haskell_quotes(),
                        Haxe =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Hcl =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Hex =>
                    
                        
                            Self::blank_quotes(),Hlsl =>
                    
                        
                            Self::c_quotes(),
                        HolyC =>
                    
                        
                            Self::c_quotes(),
                        Html =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Idris =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Ini =>
                    
                        
                            Self::blank_quotes(),IntelHex =>
                    
                        
                            Self::blank_quotes(),Isabelle =>
                    
                        &[
                                (
                                    "''",
                                    "''",
                                ),
                        ],
                    Jai =>
                    
                        
                            Self::c_quotes(),
                        Java =>
                    
                        
                            Self::c_quotes(),
                        JavaScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                                (
                                    "`",
                                    "`",
                                ),
                        ],
                    Json =>
                    
                        
                            Self::blank_quotes(),Jsx =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                                (
                                    "`",
                                    "`",
                                ),
                        ],
                    Julia =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Julius =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                                (
                                    "`",
                                    "`",
                                ),
                        ],
                    KakouneScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Kotlin =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    LLVM =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Lean =>
                    
                        
                            Self::blank_quotes(),Less =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    LinkerScript =>
                    
                        
                            Self::c_quotes(),
                        Liquid =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Lisp =>
                    
                        
                            Self::blank_quotes(),Logtalk =>
                    
                        
                            Self::pro_quotes(),
                        Lua =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Lucius =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Madlang =>
                    
                        
                            Self::blank_quotes(),Makefile =>
                    
                        
                            Self::hash_quotes(),
                        Markdown =>
                    
                        
                            Self::blank_quotes(),Meson =>
                    
                        &[
                                (
                                    "'''",
                                    "'''",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Mint =>
                    
                        
                            Self::blank_quotes(),ModuleDef =>
                    
                        
                            Self::blank_quotes(),MoonScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    MsBuild =>
                    
                        
                            Self::html_quotes(),
                        Mustache =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Nim =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    Nix =>
                    
                        
                            Self::c_quotes(),
                        NotQuitePerl =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    OCaml =>
                    
                        
                            Self::func_quotes(),
                        ObjectiveC =>
                    
                        
                            Self::c_quotes(),
                        ObjectiveCpp =>
                    
                        
                            Self::c_quotes(),
                        Odin =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Org =>
                    
                        
                            Self::blank_quotes(),Oz =>
                    
                        
                            Self::pro_quotes(),
                        PSL =>
                    
                        
                            Self::c_quotes(),
                        Pascal =>
                    
                        &[
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Perl =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Perl6 =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Pest =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Php =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Polly =>
                    
                        
                            Self::html_quotes(),
                        Pony =>
                    
                        
                            Self::c_quotes(),
                        PostCss =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    PowerShell =>
                    
                        &[
                                (
                                    "\"@",
                                    "@\"",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "@'",
                                    "'@",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Processing =>
                    
                        
                            Self::c_quotes(),
                        Prolog =>
                    
                        
                            Self::pro_quotes(),
                        Protobuf =>
                    
                        
                            Self::blank_quotes(),PureScript =>
                    
                        
                            Self::haskell_quotes(),
                        Python =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Qcl =>
                    
                        
                            Self::c_quotes(),
                        Qml =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    R =>
                    
                        
                            Self::hash_quotes(),
                        RON =>
                    
                        
                            Self::c_quotes(),
                        RPMSpecfile =>
                    
                        
                            Self::hash_quotes(),
                        Racket =>
                    
                        
                            Self::blank_quotes(),Rakefile =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Razor =>
                    
                        
                            Self::blank_quotes(),ReStructuredText =>
                    
                        
                            Self::blank_quotes(),Ruby =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    RubyHtml =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Rust =>
                    
                        &[
                                (
                                    "r#\"",
                                    "\"#",
                                ),
                                (
                                    "#\"",
                                    "\"#",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    SRecode =>
                    
                        
                            Self::blank_quotes(),Sass =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Scala =>
                    
                        
                            Self::c_quotes(),
                        Scheme =>
                    
                        
                            Self::blank_quotes(),Scons =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "'''",
                                    "'''",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Sh =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Sml =>
                    
                        
                            Self::func_quotes(),
                        Solidity =>
                    
                        
                            Self::c_quotes(),
                        SpecmanE =>
                    
                        
                            Self::blank_quotes(),Spice =>
                    
                        
                            Self::blank_quotes(),Sql =>
                    
                        &[
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Stratego =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "$[",
                                    "]",
                                ),
                                (
                                    "$<",
                                    ">",
                                ),
                                (
                                    "${",
                                    "}",
                                ),
                        ],
                    Svg =>
                    
                        
                            Self::html_quotes(),
                        Swift =>
                    
                        
                            Self::c_quotes(),
                        Swig =>
                    
                        
                            Self::c_quotes(),
                        SystemVerilog =>
                    
                        
                            Self::c_quotes(),
                        Tcl =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Tex =>
                    
                        
                            Self::blank_quotes(),Text =>
                    
                        
                            Self::blank_quotes(),Thrift =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Toml =>
                    
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "'''",
                                    "'''",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Twig =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    TypeScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                                (
                                    "`",
                                    "`",
                                ),
                        ],
                    UnrealDeveloperMarkdown =>
                    
                        
                            Self::blank_quotes(),UnrealPlugin =>
                    
                        
                            Self::blank_quotes(),
                        UnrealProject =>
                    
                        
                            Self::blank_quotes(),
                        UnrealScript =>
                    
                        
                            Self::c_quotes(),
                        UnrealShader =>
                    
                        
                            Self::c_quotes(),
                        UnrealShaderHeader =>
                    
                        
                            Self::c_quotes(),
                        UrWeb =>
                    
                        
                            Self::func_quotes(),
                        UrWebProject =>
                    
                        
                            Self::blank_quotes(),VB6 =>
                    
                        
                            Self::blank_quotes(),VBScript =>
                    
                        
                            Self::blank_quotes(),Vala =>
                    
                        
                            Self::c_quotes(),
                        Verilog =>
                    
                        
                            Self::c_quotes(),
                        VerilogArgsFile =>
                    
                        
                            Self::blank_quotes(),Vhdl =>
                    
                        
                            Self::blank_quotes(),VimScript =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    VisualBasic =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                        ],
                    VisualStudioProject =>
                    
                        
                            Self::html_quotes(),
                        VisualStudioSolution =>
                    
                        
                            Self::blank_quotes(),
                        Vue =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                                (
                                    "`",
                                    "`",
                                ),
                        ],
                    WebAssembly =>
                    
                        
                            Self::blank_quotes(),Wolfram =>
                    
                        
                            Self::func_quotes(),
                        XSL =>
                    
                        
                            Self::html_quotes(),
                        Xaml =>
                    
                        
                            Self::html_quotes(),
                        XcodeConfig =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Xml =>
                    
                        
                            Self::html_quotes(),
                        Xtend =>
                    
                        &[
                                (
                                    "'''",
                                    "'''",
                                ),
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Yaml =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    Zig =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "\\",
                                    "
",
                                ),
                        ],
                    Zsh =>
                    
                        &[
                                (
                                    "\"",
                                    "\"",
                                ),
                                (
                                    "'",
                                    "'",
                                ),
                        ],
                    
        }
    }

    /// Returns the doc quotes of a language.
    /// ```
    /// use tokei::LanguageType;
    /// let lang = LanguageType::Python;
    /// assert_eq!(lang.doc_quotes(), &[("\"\"\"", "\"\"\""), ("'''", "'''")]);
    /// ```
    pub fn doc_quotes(self) -> &'static [(&'static str, &'static str)] {
        match self {
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            Pony =>
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                        ],
            
            
            
            
            
            
            Python =>
                        &[
                                (
                                    "\"\"\"",
                                    "\"\"\"",
                                ),
                                (
                                    "'''",
                                    "'''",
                                ),
                        ],
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            
            _ => &[],
        }
    }

    /// Get language from a file path. May open and read the file.
    ///
    /// ```no_run
    /// use tokei::{Config, LanguageType};
    ///
    /// let rust = LanguageType::from_path("./main.rs", &Config::default());
    ///
    /// assert_eq!(rust, Some(LanguageType::Rust));
    /// ```
    pub fn from_path<P: AsRef<Path>>(entry: P, _config: &Config)
        -> Option<Self>
    {
        let entry = entry.as_ref();

        if let Some(filename) = fsutils::get_filename(&entry) {
            match &*filename {
                            "cmakelists.txt"
                            => return Some(CMake),
                            "dockerfile"
                            => return Some(Dockerfile),
                            "makefile"
                            => return Some(Makefile),
                            "meson.build" |
                            "meson_options.txt"
                            => return Some(Meson),
                            "rakefile"
                            => return Some(Rakefile),
                            "sconstruct" |
                            "sconscript"
                            => return Some(Scons),
                _ => ()
            }
        }

        let extension = fsutils::get_extension(&entry);
        let filetype = extension.as_ref()
            .map(|s| &**s)
            .or_else(|| get_filetype_from_shebang(&entry));

        if let Some(extension) = filetype {
            /*
            if let Some(ref languages) = config.languages {
                for (language, lang_config) in languages {
                    if lang_config.extensions.iter().any(|e| e == extension) {
                        return Some(*language)
                    }
                }
            }
            */

            match extension {
                            "abap"
                            => Some(Abap),
                            "as"
                            => Some(ActionScript),
                            "ada" |
                            "adb" |
                            "ads" |
                            "pad"
                            => Some(Ada),
                            "agda"
                            => Some(Agda),
                            "x"
                            => Some(Alex),
                            "asn1"
                            => Some(Asn1),
                            "asa" |
                            "asp"
                            => Some(Asp),
                            "asax" |
                            "ascx" |
                            "asmx" |
                            "aspx" |
                            "master" |
                            "sitemap" |
                            "webinfo"
                            => Some(AspNet),
                            "s" |
                            "asm"
                            => Some(Assembly),
                            "ahk"
                            => Some(AutoHotKey),
                            "in"
                            => Some(Autoconf),
                            "am"
                            => Some(Automake),
                            "bash"
                            => Some(Bash),
                            "bat" |
                            "btm" |
                            "cmd"
                            => Some(Batch),
                            "brs"
                            => Some(BrightScript),
                            "c" |
                            "ec" |
                            "pgc"
                            => Some(C),
                            "h"
                            => Some(CHeader),
                            "cmake"
                            => Some(CMake),
                            "cs"
                            => Some(CSharp),
                            "csh"
                            => Some(CShell),
                            "cabal"
                            => Some(Cabal),
                            "cassius"
                            => Some(Cassius),
                            "ceylon"
                            => Some(Ceylon),
                            "clj"
                            => Some(Clojure),
                            "cljc"
                            => Some(ClojureC),
                            "cljs"
                            => Some(ClojureScript),
                            "cob" |
                            "cbl" |
                            "ccp" |
                            "cobol" |
                            "cpy"
                            => Some(Cobol),
                            "coffee" |
                            "cjsx"
                            => Some(CoffeeScript),
                            "cogent"
                            => Some(Cogent),
                            "cfm"
                            => Some(ColdFusion),
                            "cfc"
                            => Some(ColdFusionScript),
                            "v"
                            => Some(Coq),
                            "cc" |
                            "cpp" |
                            "cxx" |
                            "c++" |
                            "pcc" |
                            "tpp"
                            => Some(Cpp),
                            "hh" |
                            "hpp" |
                            "hxx" |
                            "inl" |
                            "ipp"
                            => Some(CppHeader),
                            "cr"
                            => Some(Crystal),
                            "css"
                            => Some(Css),
                            "d"
                            => Some(D),
                            "dart"
                            => Some(Dart),
                            "dts" |
                            "dtsi"
                            => Some(DeviceTree),
                            "dockerfile" |
                            "dockerignore"
                            => Some(Dockerfile),
                            "resx"
                            => Some(DotNetResource),
                            "dm" |
                            "dme"
                            => Some(DreamMaker),
                            "edn"
                            => Some(Edn),
                            "el"
                            => Some(Elisp),
                            "ex" |
                            "exs"
                            => Some(Elixir),
                            "elm"
                            => Some(Elm),
                            "elv"
                            => Some(Elvish),
                            "ede"
                            => Some(EmacsDevEnv),
                            "emojic" |
                            "🍇"
                            => Some(Emojicode),
                            "erl" |
                            "hrl"
                            => Some(Erlang),
                            "fen"
                            => Some(FEN),
                            "fs" |
                            "fsi" |
                            "fsx" |
                            "fsscript"
                            => Some(FSharp),
                            "fish"
                            => Some(Fish),
                            "fbs"
                            => Some(FlatBuffers),
                            "4th" |
                            "forth" |
                            "fr" |
                            "frt" |
                            "fth" |
                            "f83" |
                            "fb" |
                            "fpm" |
                            "e4" |
                            "rx" |
                            "ft"
                            => Some(Forth),
                            "f" |
                            "for" |
                            "ftn" |
                            "f77" |
                            "pfo"
                            => Some(FortranLegacy),
                            "f03" |
                            "f08" |
                            "f90" |
                            "f95"
                            => Some(FortranModern),
                            "fst"
                            => Some(Fstar),
                            "gd"
                            => Some(GdScript),
                            "vert" |
                            "tesc" |
                            "tese" |
                            "geom" |
                            "frag" |
                            "comp" |
                            "glsl"
                            => Some(Glsl),
                            "go"
                            => Some(Go),
                            "gql" |
                            "graphql"
                            => Some(Graphql),
                            "groovy" |
                            "grt" |
                            "gtpl" |
                            "gvy"
                            => Some(Groovy),
                            "hamlet"
                            => Some(Hamlet),
                            "hbs" |
                            "handlebars"
                            => Some(Handlebars),
                            "y" |
                            "ly"
                            => Some(Happy),
                            "hs"
                            => Some(Haskell),
                            "hx"
                            => Some(Haxe),
                            "tf" |
                            "tfvars"
                            => Some(Hcl),
                            "hex"
                            => Some(Hex),
                            "hlsl"
                            => Some(Hlsl),
                            "HC" |
                            "hc"
                            => Some(HolyC),
                            "html" |
                            "htm"
                            => Some(Html),
                            "idr" |
                            "lidr"
                            => Some(Idris),
                            "ini"
                            => Some(Ini),
                            "ihex"
                            => Some(IntelHex),
                            "thy"
                            => Some(Isabelle),
                            "jai"
                            => Some(Jai),
                            "java"
                            => Some(Java),
                            "js" |
                            "mjs"
                            => Some(JavaScript),
                            "json"
                            => Some(Json),
                            "jsx"
                            => Some(Jsx),
                            "jl"
                            => Some(Julia),
                            "julius"
                            => Some(Julius),
                            "kak"
                            => Some(KakouneScript),
                            "kt" |
                            "kts"
                            => Some(Kotlin),
                            "ll"
                            => Some(LLVM),
                            "lean" |
                            "hlean"
                            => Some(Lean),
                            "less"
                            => Some(Less),
                            "lds"
                            => Some(LinkerScript),
                            "liquid"
                            => Some(Liquid),
                            "lisp" |
                            "lsp"
                            => Some(Lisp),
                            "lgt" |
                            "logtalk"
                            => Some(Logtalk),
                            "lua"
                            => Some(Lua),
                            "lucius"
                            => Some(Lucius),
                            "mad"
                            => Some(Madlang),
                            "makefile" |
                            "mak" |
                            "mk"
                            => Some(Makefile),
                            "md" |
                            "markdown"
                            => Some(Markdown),
                            "mint"
                            => Some(Mint),
                            "def"
                            => Some(ModuleDef),
                            "moon"
                            => Some(MoonScript),
                            "csproj" |
                            "vbproj" |
                            "fsproj" |
                            "props" |
                            "targets"
                            => Some(MsBuild),
                            "mustache"
                            => Some(Mustache),
                            "nim"
                            => Some(Nim),
                            "nix"
                            => Some(Nix),
                            "nqp"
                            => Some(NotQuitePerl),
                            "ml" |
                            "mli" |
                            "re" |
                            "rei"
                            => Some(OCaml),
                            "m"
                            => Some(ObjectiveC),
                            "mm"
                            => Some(ObjectiveCpp),
                            "odin"
                            => Some(Odin),
                            "org"
                            => Some(Org),
                            "oz"
                            => Some(Oz),
                            "psl"
                            => Some(PSL),
                            "pas" |
                            "pp"
                            => Some(Pascal),
                            "pl" |
                            "pm"
                            => Some(Perl),
                            "pl6" |
                            "pm6"
                            => Some(Perl6),
                            "pest"
                            => Some(Pest),
                            "php"
                            => Some(Php),
                            "polly"
                            => Some(Polly),
                            "pony"
                            => Some(Pony),
                            "pcss" |
                            "sss"
                            => Some(PostCss),
                            "ps1" |
                            "psm1" |
                            "psd1" |
                            "ps1xml" |
                            "cdxml" |
                            "pssc" |
                            "psc1"
                            => Some(PowerShell),
                            "pde"
                            => Some(Processing),
                            "p" |
                            "pro"
                            => Some(Prolog),
                            "proto"
                            => Some(Protobuf),
                            "purs"
                            => Some(PureScript),
                            "py"
                            => Some(Python),
                            "qcl"
                            => Some(Qcl),
                            "qml"
                            => Some(Qml),
                            "r"
                            => Some(R),
                            "ron"
                            => Some(RON),
                            "spec"
                            => Some(RPMSpecfile),
                            "rkt"
                            => Some(Racket),
                            "rake"
                            => Some(Rakefile),
                            "cshtml"
                            => Some(Razor),
                            "rst"
                            => Some(ReStructuredText),
                            "rb"
                            => Some(Ruby),
                            "rhtml"
                            => Some(RubyHtml),
                            "rs"
                            => Some(Rust),
                            "srt"
                            => Some(SRecode),
                            "sass" |
                            "scss"
                            => Some(Sass),
                            "sc" |
                            "scala"
                            => Some(Scala),
                            "scm" |
                            "ss"
                            => Some(Scheme),
                            "sh"
                            => Some(Sh),
                            "sml"
                            => Some(Sml),
                            "sol"
                            => Some(Solidity),
                            "e"
                            => Some(SpecmanE),
                            "ckt"
                            => Some(Spice),
                            "sql"
                            => Some(Sql),
                            "str"
                            => Some(Stratego),
                            "svg"
                            => Some(Svg),
                            "swift"
                            => Some(Swift),
                            "swg" |
                            "i"
                            => Some(Swig),
                            "sv" |
                            "svh"
                            => Some(SystemVerilog),
                            "tcl"
                            => Some(Tcl),
                            "tex" |
                            "sty"
                            => Some(Tex),
                            "text" |
                            "txt"
                            => Some(Text),
                            "thrift"
                            => Some(Thrift),
                            "toml"
                            => Some(Toml),
                            "twig"
                            => Some(Twig),
                            "ts" |
                            "tsx"
                            => Some(TypeScript),
                            "udn"
                            => Some(UnrealDeveloperMarkdown),
                            "uplugin"
                            => Some(UnrealPlugin),
                            "uproject"
                            => Some(UnrealProject),
                            "uc" |
                            "uci" |
                            "upkg"
                            => Some(UnrealScript),
                            "usf"
                            => Some(UnrealShader),
                            "ush"
                            => Some(UnrealShaderHeader),
                            "ur" |
                            "urs"
                            => Some(UrWeb),
                            "urp"
                            => Some(UrWebProject),
                            "frm" |
                            "bas" |
                            "cls"
                            => Some(VB6),
                            "vbs"
                            => Some(VBScript),
                            "vala"
                            => Some(Vala),
                            "vg" |
                            "vh"
                            => Some(Verilog),
                            "irunargs" |
                            "xrunargs"
                            => Some(VerilogArgsFile),
                            "vhd" |
                            "vhdl"
                            => Some(Vhdl),
                            "vim"
                            => Some(VimScript),
                            "vb"
                            => Some(VisualBasic),
                            "vcproj" |
                            "vcxproj"
                            => Some(VisualStudioProject),
                            "sln"
                            => Some(VisualStudioSolution),
                            "vue"
                            => Some(Vue),
                            "wat" |
                            "wast"
                            => Some(WebAssembly),
                            "nb" |
                            "wl"
                            => Some(Wolfram),
                            "xsl" |
                            "xslt"
                            => Some(XSL),
                            "xaml"
                            => Some(Xaml),
                            "xcconfig"
                            => Some(XcodeConfig),
                            "xml"
                            => Some(Xml),
                            "xtend"
                            => Some(Xtend),
                            "yaml" |
                            "yml"
                            => Some(Yaml),
                            "zig"
                            => Some(Zig),
                            "zsh"
                            => Some(Zsh),
                extension => {
                    warn!("Unknown extension: {}", extension);
                    None
                },
            }
        } else {
            None
        }
    }
}

impl FromStr for LanguageType {
    type Err = &'static str;

    fn from_str(from: &str) -> Result<Self, Self::Err> {
        match &*from {
                    "ABAP"
                
                    => Ok(Abap),
                    "ActionScript"
                    => Ok(ActionScript),
                    "Ada"
                    => Ok(Ada),
                    "Agda"
                    => Ok(Agda),
                    "Alex"
                    => Ok(Alex),
                    "ASN.1"
                
                    => Ok(Asn1),
                    "ASP"
                
                    => Ok(Asp),
                    "ASP.NET"
                
                    => Ok(AspNet),
                    "Assembly"
                    => Ok(Assembly),
                    "AutoHotKey"
                    => Ok(AutoHotKey),
                    "Autoconf"
                    => Ok(Autoconf),
                    "Automake"
                    => Ok(Automake),
                    "BASH"
                
                    => Ok(Bash),
                    "Batch"
                    => Ok(Batch),
                    "BrightScript"
                    => Ok(BrightScript),
                    "C"
                    => Ok(C),
                    "C Header"
                
                    => Ok(CHeader),
                    "CMake"
                    => Ok(CMake),
                    "C#"
                
                    => Ok(CSharp),
                    "C Shell"
                
                    => Ok(CShell),
                    "Cabal"
                    => Ok(Cabal),
                    "Cassius"
                    => Ok(Cassius),
                    "Ceylon"
                    => Ok(Ceylon),
                    "Clojure"
                    => Ok(Clojure),
                    "ClojureC"
                    => Ok(ClojureC),
                    "ClojureScript"
                    => Ok(ClojureScript),
                    "COBOL"
                
                    => Ok(Cobol),
                    "CoffeeScript"
                    => Ok(CoffeeScript),
                    "Cogent"
                    => Ok(Cogent),
                    "ColdFusion"
                    => Ok(ColdFusion),
                    "ColdFusion CFScript"
                
                    => Ok(ColdFusionScript),
                    "Coq"
                    => Ok(Coq),
                    "C++"
                
                    => Ok(Cpp),
                    "C++ Header"
                
                    => Ok(CppHeader),
                    "Crystal"
                    => Ok(Crystal),
                    "CSS"
                
                    => Ok(Css),
                    "D"
                    => Ok(D),
                    "Dart"
                    => Ok(Dart),
                    "Device Tree"
                
                    => Ok(DeviceTree),
                    "Dockerfile"
                    => Ok(Dockerfile),
                    ".NET Resource"
                
                    => Ok(DotNetResource),
                    "Dream Maker"
                
                    => Ok(DreamMaker),
                    "Edn"
                    => Ok(Edn),
                    "Emacs Lisp"
                
                    => Ok(Elisp),
                    "Elixir"
                    => Ok(Elixir),
                    "Elm"
                    => Ok(Elm),
                    "Elvish"
                    => Ok(Elvish),
                    "Emacs Dev Env"
                
                    => Ok(EmacsDevEnv),
                    "Emojicode"
                    => Ok(Emojicode),
                    "Erlang"
                    => Ok(Erlang),
                    "FEN"
                
                    => Ok(FEN),
                    "F#"
                
                    => Ok(FSharp),
                    "Fish"
                    => Ok(Fish),
                    "FlatBuffers Schema"
                
                    => Ok(FlatBuffers),
                    "Forth"
                    => Ok(Forth),
                    "FORTRAN Legacy"
                
                    => Ok(FortranLegacy),
                    "FORTRAN Modern"
                
                    => Ok(FortranModern),
                    "F*"
                
                    => Ok(Fstar),
                    "GDScript"
                
                    => Ok(GdScript),
                    "GLSL"
                
                    => Ok(Glsl),
                    "Go"
                    => Ok(Go),
                    "GraphQL"
                
                    => Ok(Graphql),
                    "Groovy"
                    => Ok(Groovy),
                    "Hamlet"
                    => Ok(Hamlet),
                    "Handlebars"
                    => Ok(Handlebars),
                    "Happy"
                    => Ok(Happy),
                    "Haskell"
                    => Ok(Haskell),
                    "Haxe"
                    => Ok(Haxe),
                    "HCL"
                
                    => Ok(Hcl),
                    "HEX"
                
                    => Ok(Hex),
                    "HLSL"
                
                    => Ok(Hlsl),
                    "HolyC"
                    => Ok(HolyC),
                    "HTML"
                
                    => Ok(Html),
                    "Idris"
                    => Ok(Idris),
                    "INI"
                
                    => Ok(Ini),
                    "Intel HEX"
                
                    => Ok(IntelHex),
                    "Isabelle"
                    => Ok(Isabelle),
                    "JAI"
                
                    => Ok(Jai),
                    "Java"
                    => Ok(Java),
                    "JavaScript"
                    => Ok(JavaScript),
                    "JSON"
                
                    => Ok(Json),
                    "JSX"
                
                    => Ok(Jsx),
                    "Julia"
                    => Ok(Julia),
                    "Julius"
                    => Ok(Julius),
                    "Kakoune script"
                
                    => Ok(KakouneScript),
                    "Kotlin"
                    => Ok(Kotlin),
                    "LLVM"
                    => Ok(LLVM),
                    "Lean"
                    => Ok(Lean),
                    "LESS"
                
                    => Ok(Less),
                    "LD Script"
                
                    => Ok(LinkerScript),
                    "Liquid"
                
                    => Ok(Liquid),
                    "Lisp"
                    => Ok(Lisp),
                    "Logtalk"
                    => Ok(Logtalk),
                    "Lua"
                    => Ok(Lua),
                    "Lucius"
                    => Ok(Lucius),
                    "Madlang"
                    => Ok(Madlang),
                    "Makefile"
                    => Ok(Makefile),
                    "Markdown"
                    => Ok(Markdown),
                    "Meson"
                    => Ok(Meson),
                    "Mint"
                    => Ok(Mint),
                    "Module-Definition"
                
                    => Ok(ModuleDef),
                    "MoonScript"
                    => Ok(MoonScript),
                    "MSBuild"
                
                    => Ok(MsBuild),
                    "Mustache"
                    => Ok(Mustache),
                    "Nim"
                    => Ok(Nim),
                    "Nix"
                    => Ok(Nix),
                    "Not Quite Perl"
                
                    => Ok(NotQuitePerl),
                    "OCaml"
                    => Ok(OCaml),
                    "Objective-C"
                
                    => Ok(ObjectiveC),
                    "Objective-C++"
                
                    => Ok(ObjectiveCpp),
                    "Odin"
                    => Ok(Odin),
                    "Org"
                    => Ok(Org),
                    "Oz"
                    => Ok(Oz),
                    "PSL Assertion"
                
                    => Ok(PSL),
                    "Pascal"
                    => Ok(Pascal),
                    "Perl"
                    => Ok(Perl),
                    "Perl6"
                    => Ok(Perl6),
                    "Pest"
                    => Ok(Pest),
                    "PHP"
                
                    => Ok(Php),
                    "Polly"
                    => Ok(Polly),
                    "Pony"
                    => Ok(Pony),
                    "PostCSS"
                
                    => Ok(PostCss),
                    "PowerShell"
                    => Ok(PowerShell),
                    "Processing"
                    => Ok(Processing),
                    "Prolog"
                    => Ok(Prolog),
                    "Protocol Buffers"
                
                    => Ok(Protobuf),
                    "PureScript"
                    => Ok(PureScript),
                    "Python"
                    => Ok(Python),
                    "QCL"
                
                    => Ok(Qcl),
                    "QML"
                
                    => Ok(Qml),
                    "R"
                    => Ok(R),
                    "Rusty Object Notation"
                
                    => Ok(RON),
                    "RPM Specfile"
                
                    => Ok(RPMSpecfile),
                    "Racket"
                    => Ok(Racket),
                    "Rakefile"
                    => Ok(Rakefile),
                    "Razor"
                    => Ok(Razor),
                    "ReStructuredText"
                    => Ok(ReStructuredText),
                    "Ruby"
                    => Ok(Ruby),
                    "Ruby HTML"
                
                    => Ok(RubyHtml),
                    "Rust"
                    => Ok(Rust),
                    "SRecode Template"
                
                    => Ok(SRecode),
                    "Sass"
                    => Ok(Sass),
                    "Scala"
                    => Ok(Scala),
                    "Scheme"
                    => Ok(Scheme),
                    "Scons"
                    => Ok(Scons),
                    "Shell"
                
                    => Ok(Sh),
                    "Standard ML (SML)"
                
                    => Ok(Sml),
                    "Solidity"
                
                    => Ok(Solidity),
                    "Specman e"
                
                    => Ok(SpecmanE),
                    "Spice Netlist"
                
                    => Ok(Spice),
                    "SQL"
                
                    => Ok(Sql),
                    "Stratego/XT"
                
                    => Ok(Stratego),
                    "SVG"
                
                    => Ok(Svg),
                    "Swift"
                    => Ok(Swift),
                    "SWIG"
                
                    => Ok(Swig),
                    "SystemVerilog"
                    => Ok(SystemVerilog),
                    "TCL"
                
                    => Ok(Tcl),
                    "TeX"
                
                    => Ok(Tex),
                    "Plain Text"
                
                    => Ok(Text),
                    "Thrift"
                    => Ok(Thrift),
                    "TOML"
                
                    => Ok(Toml),
                    "Twig"
                
                    => Ok(Twig),
                    "TypeScript"
                    => Ok(TypeScript),
                    "Unreal Markdown"
                
                    => Ok(UnrealDeveloperMarkdown),
                    "Unreal Plugin"
                
                    => Ok(UnrealPlugin),
                    "Unreal Project"
                
                    => Ok(UnrealProject),
                    "Unreal Script"
                
                    => Ok(UnrealScript),
                    "Unreal Shader"
                
                    => Ok(UnrealShader),
                    "Unreal Shader Header"
                
                    => Ok(UnrealShaderHeader),
                    "Ur/Web"
                
                    => Ok(UrWeb),
                    "Ur/Web Project"
                
                    => Ok(UrWebProject),
                    "VB6"
                
                    => Ok(VB6),
                    "VBScript"
                
                    => Ok(VBScript),
                    "Vala"
                    => Ok(Vala),
                    "Verilog"
                    => Ok(Verilog),
                    "Verilog Args File"
                
                    => Ok(VerilogArgsFile),
                    "VHDL"
                
                    => Ok(Vhdl),
                    "Vim Script"
                
                    => Ok(VimScript),
                    "Visual Basic"
                
                    => Ok(VisualBasic),
                    "Visual Studio Project"
                
                    => Ok(VisualStudioProject),
                    "Visual Studio Solution"
                
                    => Ok(VisualStudioSolution),
                    "Vue"
                
                    => Ok(Vue),
                    "WebAssembly"
                    => Ok(WebAssembly),
                    "Wolfram"
                    => Ok(Wolfram),
                    "XSL"
                
                    => Ok(XSL),
                    "XAML"
                
                    => Ok(Xaml),
                    "Xcode Config"
                
                    => Ok(XcodeConfig),
                    "XML"
                
                    => Ok(Xml),
                    "Xtend"
                    => Ok(Xtend),
                    "YAML"
                
                    => Ok(Yaml),
                    "Zig"
                    => Ok(Zig),
                    "Zsh"
                    => Ok(Zsh),
            _ => Err("Language not found, please use `-l` to see all available\
                     languages."),
        }
    }
}

impl fmt::Display for LanguageType {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "{}", self.name())
    }
}


impl<'a> From<LanguageType> for Cow<'a, LanguageType> {
    fn from(from: LanguageType) -> Self {
        Cow::Owned(from)
    }
}

impl<'a> From<&'a LanguageType> for Cow<'a, LanguageType> {
    fn from(from: &'a LanguageType) -> Self {
        Cow::Borrowed(from)
    }
}


/// This is for getting the file type from the first line of a file
pub fn get_filetype_from_shebang(file: &Path) -> Option<&'static str>
{
    let file = match File::open(file) {
        Ok(file) => file,
        _ => return None,
    };

    let mut buf = BufReader::new(file);
    let mut line = String::new();
    let _ = buf.read_line(&mut line);

    let mut words = line.split_whitespace();
    match words.next() {
        Some("#!/bin/sh") => Some("sh"),
        Some("#!/bin/csh") => Some("csh"),
        Some("#!/usr/bin/perl") => Some("pl"),
        Some("#!/usr/bin/env") => {
            if let Some(word) = words.next() {
                match word {
                                "bash"
                                => Some("bash"),
                                "csh"
                                => Some("csh"),
                                "elvish"
                                => Some("elv"),
                                "fish"
                                => Some("fish"),
                                "python"
                                    |
                                "python2"
                                    |
                                "python3"
                                => Some("py"),
                                "ruby"
                                => Some("rb"),
                                "sh"
                                => Some("sh"),
                    env => {
                        warn!("Unknown environment: {:?}", env);
                        None
                    }
                }
            } else {
                None
            }
        }
        _ => None,
    }
}

